//=============================================================================
// ANNAPlayer. (C) 2012 "Dei" & Nobody. Edit by Cozmo, 2018
//=============================================================================
class ANNAPlayer extends MTLPlayer abstract;

#exec OBJ LOAD FILE="..\System\CDXExtension.u"  //is this actually needed?
#exec OBJ LOAD FILE="..\System\DXWeapon2.u"

//#exec TEXTURE IMPORT NAME=DX_HitMarker FILE=Textures\DX_HitMarker.pcx GROUP=UI
//#exec AUDIO IMPORT FILE="Sounds\QFeedBack.wav" NAME="QFeedBack" GROUP="Generic" //moved to CDXExtension

var float defaultMaxFrobDistance;
var bool bSpectatingEnabled;
var ANNAManager Manager;
var float spectateStartTime;
var ANNAGameMode AGM;
var string mpObjective;
var bool bMuted;
var DeusExPlayer mutedPlayer[8];
var float creationTime;
var int nextShotTime;
var bool bDemoPlayback;
var actor aSuiTimer;
var actor aSpecTimer;
//var Texture HMTex;
//var float HMEndTime;
var Sound HitFeedback;
var float inFightTimer;
var float lastHealedTime;
var string CDXVerStr;

replication
{
    reliable if(ROLE == ROLE_Authority)
      clientStopFiring, clientUpdateURL, defaultMaxFrobDistance, bSpectatingEnabled, ClientsideEffects, SetMPObj, PlayHitFeedback, ClientCC;
      
	reliable if (Role < ROLE_Authority)
		Spectate, cc, CV, Silence, Unsilence, CheckDemoPlayback; //Disconnect was here
}

/*
simulated function Tick(float deltaTime) //TICK DOESN'T SEEM TO CALL AT ALL. EVER. ???
{
	ClientMessage("...");
	
	if(Role < ROLE_Authority)
	{
		if(ViewTarget != None)
		{
			if(viewTarget.IsA('PlayerPawn'))
			{
				if(ViewTarget != Self)
				{
					Pawn(ViewTarget).ViewRotation = ViewTarget.Rotation; //doesn't crash, but doesn't work...
				}
			}
		}
	}
	
	Super.Tick(deltaTime);
}
*/

//exec function demotest()
//{
//	bDemoPlayback = true;
//}

simulated function ClientCC(string cmd)
{
	ConsoleCommand(cmd);
}

function bool CheckDemoPlayback() //will expand on this later
{
	if(bDemoPlayback == false) //some clientside functions already check for NM3, so they can check this var instead
	{
		if(Level.NetMode == 3)
		{
			bDemoPlayback = true;
			return true;
		}
		else
		{
			return false;
		}
	}
	
	return true;
}

exec function CV(optional class<actor> aClass ) //was cheatview2. todo: rename to something sensible?
{
	local actor other, first;
	local bool bFound;

	if(CheckDemoPlayback() == false)
	{
		if(!IsInState('PlayerSpectating'))
		{
			if( !bCheatsEnabled )
				return;

			if( !bAdmin && Level.NetMode!=NM_Standalone )
				return;
		}
	}
	
	if(aClass == None)
		aClass = Class'DeusExPlayer';

	first = None;
	
	ForEach AllActors( aClass, other )
	{
		if (first == None && other != self && other.IsInState('PlayerSpectating') == false)
		{
			first = other;
			bFound = true;
		}
		
		if ( other == ViewTarget ) 
			first = None;
	}  

	if ( first != None )
	{
		if ( first.IsA('Pawn') && Pawn(first).bIsPlayer && (Pawn(first).PlayerReplicationInfo.PlayerName != ""))
			ClientMessage(ViewingFrom@Pawn(first).PlayerReplicationInfo.PlayerName, 'Event', true);
		else
			ClientMessage(ViewingFrom@first, 'Event', true);
			
		ViewTarget = first;
		
		if(bDemoPlayback == false)
			bBehindView = false;
		else
			bBehindView = true;
	}
	else
	{
		if ( bFound )
		{
			ClientMessage(ViewingFrom@OwnCamera, 'Event', true);
			bBehindView = false;
		}
		else
		{
			ClientMessage(FailedView, 'Event', true);
		}
		
		ViewTarget = None;
	}

//	bBehindView = ( ViewTarget != None );
	
//	if ( bBehindView )
	if(ViewTarget != None)
	{
		ViewTarget.BecomeViewTarget();
		Pawn(ViewTarget).BaseEyeHeight = BaseEyeHeight; //test
	}
}

exec function ToggleBehindView()
{
	local bool bSkip;
	
	if(bDemoPlayback == false)
	{
		if(IsInState('PlayerSpectating') && viewTarget == None)
			return;
			
		if(IsInState('PlayerSpectating') == false && bAdmin == false)
			return;
	}
	
	bBehindView = !bBehindView;
}

exec function ToggleScope()
{
	local DeusExWeapon W;

	if (RestrictInput())
		return;

	W = DeusExWeapon(Weapon);
	
	if(Role < ROLE_Authority) //new test
	{
		if (W != None)
			W.ScopeToggle();
	}
}

function CalcBehindView(out vector CameraLocation, out rotator CameraRotation, float Dist)
{
	local vector View,HitLocation,HitNormal;
	local float ViewDist;

	CameraRotation = ViewRotation;
	View = vect(1,0,0) >> CameraRotation;
	CameraLocation.Z += EyeHeight;
	
	//don't go through the world
	if( Trace( HitLocation, HitNormal, CameraLocation - (Dist + 30) * vector(CameraRotation), CameraLocation ) != None )
		ViewDist = FMin( (CameraLocation - HitLocation) Dot View, Dist );
	else
		ViewDist = Dist;
		
	CameraLocation -= (ViewDist - 30) * View; 
}

function CalcBehindViewDemo(out vector CameraLocation, out rotator CameraRotation, float Dist)
{
	local vector View,HitLocation,HitNormal;
	local float ViewDist;

	//CameraRotation = ViewRotation;
	View = vect(1,0,0) >> CameraRotation;
	CameraLocation.Z += EyeHeight;
	
	//don't go through the world
	if( Trace( HitLocation, HitNormal, CameraLocation - (Dist + 30) * vector(CameraRotation), CameraLocation ) != None )
		ViewDist = FMin( (CameraLocation - HitLocation) Dot View, Dist );
	else
		ViewDist = Dist;
		
	CameraLocation -= (ViewDist - 30) * View; 
}

event PlayerCalcView(out actor ViewActor, out vector CameraLocation, out rotator CameraRotation )
{
	local Pawn PTarget;
	
	if(bDemoPlayback == true)
	{
		if(ViewTarget != None && IsInState('PlayerSpectating') == false)
		{
			ViewActor = ViewTarget;
			CameraLocation = ViewTarget.Location;
			CameraRotation = ViewTarget.Rotation;
			PTarget = Pawn(ViewTarget);
		
			if ( PTarget != None )
			{
				CameraRotation = PTarget.Rotation; //I guess viewrot isn't repl to other clients, which does make sense. I'll repl or use third-person cam?
						
				//if ( bBehindView ) //can re-implement if I ever get first-person working nicely
					CalcBehindViewDemo(CameraLocation, CameraRotation, 150);
			}
		
			//if ( bBehindView )
			//	CalcBehindView(CameraLocation, CameraRotation, 180);
			
			return;
		}
	}
	
	Super.PlayerCalcView(ViewActor, CameraLocation, CameraRotation);

/*
	//vanilla engine.u code:
	if ( ViewTarget != None )
	{
		ViewActor = ViewTarget;
		CameraLocation = ViewTarget.Location;
		CameraRotation = ViewTarget.Rotation;
		PTarget = Pawn(ViewTarget);
		
		if ( PTarget != None )
		{
			if ( Level.NetMode == NM_Client )
			{
				if ( PTarget.bIsPlayer )
					PTarget.ViewRotation = TargetViewRotation;
				
				PTarget.EyeHeight = TargetEyeHeight;
				
				if ( PTarget.Weapon != None )
					PTarget.Weapon.PlayerViewOffset = TargetWeaponViewOffset;
			}
			
			if ( PTarget.bIsPlayer )
				CameraRotation = PTarget.ViewRotation;
				
			if ( !bBehindView )
				CameraLocation.Z += PTarget.EyeHeight;
		}
		
		if ( bBehindView )
			CalcBehindView(CameraLocation, CameraRotation, 180);
			
		return;
	}

	ViewActor = Self;
	CameraLocation = Location;

	if( bBehindView ) //up and behind
		CalcBehindView(CameraLocation, CameraRotation, 150);
	else
	{
		// First-person view.
		CameraRotation = ViewRotation;
		CameraLocation.Z += EyeHeight;
		CameraLocation += WalkBob;
	}
*/
}

/*
 Cozmo: I've tried a few different hitmarkers, but none of them look good with DX crosshairs
simulated event RenderOverlays( canvas Can )
{
	local int MarkerBrightness;
	local float HMTimeLeft;
	local pawn p;
	local DeusExPlayer DXP;
	local Texture T;

	Super.RenderOverlays(Can);

	if(HMEndTime > Level.TimeSeconds)
	{
		HMTimeLeft = HMEndTime - Level.TimeSeconds;
		MarkerBrightness = HMTimeLeft * 1275;
		Can.Style = 3;
		
		MarkerBrightness = 200;
		
		if(Headshot)
		{
			Can.SetPos((Can.SizeX / 2) - HMTex.uClamp * 0.75, (Can.SizeY / 2) - HMTex.vClamp * 0.75);
			Can.DrawColor.R = MarkerBrightness;
			Can.DrawColor.G = 0;
			Can.DrawColor.B = 0;
			Can.DrawTile(HMTex, HMTex.uClamp * 1.5, HMTex.vClamp * 1.5, 0, 0, HMTex.uClamp, HMTex.vClamp);
		}
		else
		{
			Can.SetPos((Can.SizeX / 2) - HMTex.uClamp * 0.5, (Can.SizeY / 2) - HMTex.vClamp * 0.5);
			Can.DrawColor.R = MarkerBrightness;
			Can.DrawColor.G = MarkerBrightness;
			Can.DrawColor.B = MarkerBrightness;
			Can.DrawTile(HMTex, HMTex.uClamp, HMTex.vClamp, 0, 0, HMTex.uClamp, HMTex.vClamp);
		}
		
	}
}
*/

/**
  Spawning the AntiCheat actor.
*/
function PostBeginPlay()
{
    local ANNAManager Manager;
	local ANNAMutator AM;
	local ANNAGameMode AGM2;
	local DeusExMPGame gameClass;

    Super.PostBeginPlay();

    Spawn(class'ANNAAntiCheat', self);

    if(Manager == None)
      Manager = findManager();

    if(Manager != None)
      defaultMaxFrobDistance = Manager.MaxFrobDistance;

	gameClass = DeusExMPGame(level.Game);
	
	SetTimer2('playerhelp', 1.5);

//	if(TeamDMGame(gameClass) != None)
//		AGM = CDX_Team(gameClass).AGM;
//	else
//		AGM = CDX_DeathMatch(gameClass).AGM;
		
/*	
	foreach AllActors(class'ANNAGameMode', AGM2) 
		AGM = AGM2;
		
	if(AGM == None)
	{
		AGM = Spawn(class'ANNAGameMode', Self);
	}
*/	
	creationTime = Level.TimeSeconds;
}

function PostPostBeginPlay()
{	
	Super(PlayerPawnExt).PostPostBeginPlay();

	// Bind any conversation events to this DeusExPlayer
	ConBindEvents();

	// Restore colors that the user selected (as opposed to those
	// stored in the savegame)
	ThemeManager.SetMenuThemeByName(MenuThemeName);
	ThemeManager.SetHUDThemeByName(HUDThemeName);

	if ((Level.NetMode != NM_Standalone) && ( killProfile == None ))
		killProfile = Spawn(class'CDXKillerProfile', Self);
		
	if ( killProfile != None )
		killProfile.NetPriority=2.00;
}

/**
  Find and return the ANNAManager
*/
function ANNAManager findManager()
{
  local ANNAManager curManager;
  local bool bFound;

  if(Manager != None)
    return Manager;

  foreach AllActors(class'ANNAManager', curManager)
    if(curManager != None)
      return curManager;

  return none;
}

//Cozmo: another hack since I can't use Tick() or Timer() in this class
function actor SetTimer2(name EventToCall, float Time)
{
	local actor a;
	
	a = Spawn(Class'Timer2');
	a.SetOwner(Self);
	a.Event = EventToCall;
	a.SetTimer(Time, false);
	return a;
}

function InvokeComputerScreen(Computers computerToActivate, float CompHackTime, float ServerLevelTime)
{
	if(CheckDemoPlayback())
		return;
		
	Super.InvokeComputerScreen(computerToActivate, CompHackTime, ServerLevelTime);
}

/**
  Before we actually frob our target, reset the MaxFrobDistance.
*/
function DoFrob(Actor Frobber, Inventory frobWith)
{
	local DeusExMover VBA;
	
	//from ANNA
	HighlightCenterObject();
	
	//from MTL
	if ( FrobTarget == None )
	{
		return;
	}
	if ( Level.NetMode != 0 )
	{
		if ( (V6D != None) && FrobTarget.IsA('Computers') && (Computers(FrobTarget).curFrobber == None) )
		{
			V6D.Destroy();
		}
		
		VBA=DeusExMover(FrobTarget);
		
		if ( VBA != None )
		{
			if ( (V6F != None) && (V6F.Z90 != None) )
			{
				V6F.V14(VBA);
			} else {
				if ( VBA.bInitialLocked && ((VBA.KeyNum != 0) || (VBA.PrevKeyNum != 0)) )
				{
					return;
				}
			}
		}
	}
	
	//from CDX
	//do a los trace and make sure this thing can actually be frobbed!
	//make sure to offset or you'll get dumb situations where you try to frob the edge of an actor and fail

	Super(DeusExPlayer).DoFrob(Frobber, frobWith);
	
	//Cozmo: prevent any duplication. Note: using skilledtools counts as frobbing lol
	if(frobTarget != none && frobTarget.IsA('Inventory'))
		frobTarget = none; 
}

//Cozmo: couldn't we just add FrobDistance check here? Maybe other checks too, such as trace from frobber to actor... todo:
function bool IsFrobbable(actor A)
{
	if (!A.bHidden)
		if (A.IsA('Mover') || A.IsA('DeusExDecoration') || A.IsA('Inventory') ||
			A.IsA('ScriptedPawn') || A.IsA('DeusExCarcass') || A.IsA('DeusExProjectile'))
			return True;

	return False;
}

/*
function bool HandleItemPickup (Actor FrobTarget, optional bool bSearchOnly) //copied from MTL (I think their main change was for single-ammo frob of tknives)
{
	local bool VB4;
	local bool bCanPickup;
	local bool VB5; //same as bSlotSearchNeeded
	local Inventory foundItem;

	VB5=True;
	bCanPickup=True;
	VB4=False;
	
	if(V7B) //throwing knife picked up lol 
	{
		if(FrobTarget.IsA('DeusExWeapon'))
		{
			DeusExWeapon(FrobTarget).PickupAmmoCount=1;
			DeusExWeapon(FrobTarget).mpPickupAmmoCount=1;
		}
		else
		{
			if(FrobTarget.IsA('Ammo'))
			{
				Ammo(FrobTarget).AmmoAmount=1;
			}
		}
	}
	
	if(FrobTarget.IsA('DataVaultImage') || FrobTarget.IsA('NanoKey') || FrobTarget.IsA('Credits'))
	{
		VB5=False;
	}
	else
	{
		if(FrobTarget.IsA('DeusExPickup'))
		{
			// If an object of this type already exists in the player's inventory *AND*
			// the object is stackable, then we don't need to search.

			if((FindInventoryType(FrobTarget.Class) != None) && DeusExPickup(FrobTarget).bCanHaveMultipleCopies)
			{
				VB5=False;
			}
		}
		else
		{
			// If this isn't ammo or a weapon that we already have, 
			// check if there's enough room in the player's inventory
			// to hold this item.

			foundItem = GetWeaponOrAmmo(Inventory(FrobTarget));
			
			if(foundItem != None )
			{
				VB5=False;
				
				// if this is an ammo, and we're full of it, abort the pickup
				if(foundItem.IsA('Ammo') )
				{
					if(Ammo(foundItem).AmmoAmount >= Ammo(foundItem).MaxAmmo)
					{
						ClientMessage(TooMuchAmmo);
						bCanPickup=False;
					}
				}
				else
				{
					// If this is a grenade or LAM (what a pain in the ass) then also check
					// to make sure we don't have too many grenades already
					if(foundItem.IsA('WeaponEMPGrenade') || foundItem.IsA('WeaponGasGrenade') || foundItem.IsA('WeaponNanoVirusGrenade') || foundItem.IsA('WeaponLAM'))
					{
						if(DeusExWeapon(foundItem).AmmoType.AmmoAmount >= DeusExWeapon(foundItem).AmmoType.MaxAmmo )
						{
							ClientMessage(TooMuchAmmo);
							bCanPickup=False;
						}
					}
					else
					{
						// Otherwise, if this is a single-use weapon, prevent the player
						// from picking up
						if(foundItem.IsA('Weapon'))
						{
							// If these fields are set as checked, then this is a 
							// single use weapon, and if we already have one in our 
							// inventory another cannot be picked up (puke). 
							
							//bCanPickup = !(Weapon(foundItem).ReloadCount == 0) && (Weapon(foundItem).PickupAmmoCount == 0) && (Weapon(foundItem).AmmoName != None);  //Cozmo: maybe a replication problem?
							if(Weapon(foundItem).PickupAmmoCount == 0)
								bCanPickup = false;

							if (bCanPickup == false)
								ClientMessage(Sprintf(CanCarryOnlyOne,foundItem.ItemName));
						}
					}
				}
			}
			else
			{
				if(V7B)
				{
					VB4=True;
				}
			}
		}
	}
	
	//clientmessage("debug: thing called, bCanPickup: "$bCanPickup); //note: this didn't call whne frob failed
	
	if(VB5 && bCanPickup)
	{
		if(FindInventorySlot(Inventory(FrobTarget),bSearchOnly) == False)
		{
			ClientMessage(Sprintf(InventoryFull,Inventory(FrobTarget).ItemName));
			bCanPickup = False;
			ServerConditionalNotifyMsg(11);
		}
	}
	
	if(bCanPickup)
	{
		if ( (Level.NetMode != 0) && (FrobTarget.IsA('DeusExWeapon') || FrobTarget.IsA('DeusExAmmo')) )
		{
			//PlaySound(Sound'WeaponPickup',3,0.50 + FRand() * 0.25,,256.00,0.95 + FRand() * 0.10);
			PlaySound(sound'WeaponPickup', SLOT_Interact, 0.5+FRand()*0.25, , 256, 0.95+FRand()*0.1);
		}
		
		DoFrob(self,inHand);
		
		if(Level.NetMode != 0)
		{
			// This is bad. We need to reset the number so restocking works
			if(FrobTarget.IsA('DeusExWeapon') && (DeusExWeapon(FrobTarget).PickupAmmoCount == 0))
				//DeusExWeapon(FrobTarget).PickupAmmoCount=DeusExWeapon(FrobTarget).Default.mpPickupAmmoCount * 3;
				DeusExWeapon(FrobTarget).PickUpAmmoCount=DeusExWeapon(FrobTarget).AmmoType.MaxAmmo;
		}
		
		if(VB4) //this section is for MTL 1 knife pickup
		{
			foundItem = GetWeaponOrAmmo(Inventory(FrobTarget));
			
			if(DeusExWeapon(foundItem) != None)
				DeusExWeapon(foundItem).AmmoType.AmmoAmount=1;
		}
	}
	
	V7B=False;
	return bCanPickup;
}
*/

/**
  Reset the MaxFrobDistance
*/
function HighlightCenterObject()
{
  MaxFrobDistance = defaultMaxFrobDistance;
  Super.HighlightCenterObject();
}

/**
  Make sure the player uses our customized AugmentationManager 
*/
function InitializeSubSystems()
{
	local Skill VAC;
  
  if(Manager == None)
    Manager = findManager();

  bSpectatingEnabled = Manager.bEnableSpectating;

	if((Level.NetMode == NM_Standalone) && (BarkManager == None))
		BarkManager = Spawn(Class'BarkManager', self);

	CreateColorThemeManager();
	if(ThemeManager != None)
		ThemeManager.SetOwner(self);

	if(Level.NetMode != NM_Standalone)
	{
		if((AugmentationSystem != None) && !AugmentationSystem.IsA('ANNAAugmentationManager'))
		{
			AugmentationSystem.ResetAugmentations();
			AugmentationSystem.Destroy();
			AugmentationSystem = None;
		}

		if((SkillSystem != None) && !SkillSystem.IsA('CBPSkillManager'))
		{
			VAC = SkillSystem.FirstSkill;

			while(VAC != None)
			{
				VAC.Destroy();
				VAC = VAC.Next;
			}
			SkillSystem.Destroy();
			SkillSystem = None;
		}
	}

	if(AugmentationSystem == None)
	{
		AugmentationSystem = Spawn(Class'ANNAAugmentationManager', self);
		AugmentationSystem.CreateAugmentations(self);
		AugmentationSystem.AddDefaultAugmentations();
	}
  else
  {
		AugmentationSystem.SetPlayer(self);
		AugmentationSystem.SetOwner(self);
	}

	if(SkillSystem == None)
	{
		SkillSystem = Spawn(Class'CBPSkillManager',self);
		SkillSystem.CreateSkills(self);
	}
  else
  {
		SkillSystem.SetPlayer(self);
		SkillSystem.SetOwner(self);
	}

	if((Level.NetMode == NM_Standalone) || !bBeltIsMPInventory)
		CreateKeyRing();
}

/**
  Make sure the player uses our customized HUD 
*/
event Possess()
{
	local DeusExRootWindow root;

	Super.Possess();

	root = DeusExRootWindow(RootWindow);
	if(root != None)
	{
		if(root.HUD != None)
			root.HUD.Destroy();

		root.HUD = ANNAHUD(root.NewChild(Class'ANNAHUD'));
		root.HUD.UpdateSettings(self);
		root.HUD.SetWindowAlignments(HALIGN_Full, VALIGN_Full, 0.00, 0.00);
	}
}

/**
  Make sure the player uses our new scoreboard for the multiplayer-win screen.
*/
function ShowMultiplayerWin(String winnerName, int winningTeam, String Killer, String Killee, String Method)
{
	local ANNAHUDMP mpScr;
	local DeusExRootWindow root;

	if((Player != None) && (Player.Console != None))
		Player.Console.ClearMessages();

	root = DeusExRootWindow(rootWindow);

	if(root != None)
	{
		mpScr = ANNAHUDMP(root.InvokeUIScreen(Class'ANNAHUDMP', True));
		root.MaskBackground(True);

		if(mpScr != None)
		{
			mpScr.winnerName = winnerName;
			mpScr.winningTeam = winningTeam;
			mpScr.winKiller = Killer;
			mpScr.winKillee = Killee;
			mpScr.winMethod = Method;
		}
	}

   if(PlayerIsClient())
      if(AugmentationSystem != None)
         AugmentationSystem.DeactivateAll();
}

/**
  New <i>server -> client</i> function to tell the client to stop with firing.
  In this case the client is supposed to stop, if the player jumps into the water.
*/
simulated function clientStopFiring()
{
  DeusExWeapon(inHand).GotoState('SimFinishFire');
  DeusExWeapon(inHand).PlayIdleAnim();
}

simulated function clientUpdateURL(string NewOption, string NewValue, bool bSaveDefault)
{
  UpdateURL(NewOption, NewValue, bSaveDefault);
}

/*
//Cozmo: don't call this if we're in demo playback *and* viewing from another perspective
function MultiplayerDeathMsg( Pawn killer, bool killedSelf, bool valid, String killerName, String killerMethod )
{
	if(bDemoPlayback)
	{
		if(ViewTarget != None)
		{
			return;
		}
	}
	
	Super.MultiplayerDeathMsg(killer, killedSelf, valid, killerName, killerMethod);
}*/

// ----------------------------------------------------------------------
// MultiplayerDeathMsg()
// ----------------------------------------------------------------------
function MultiplayerDeathMsg( Pawn killer, bool killedSelf, bool valid, String killerName, String killerMethod )
{
	local MultiplayerMessageWin2 mmw;
	local DeusExRootWindow root;
	
	if(bDemoPlayback)
	{
		if(ViewTarget != None) //if demo-spectating, don't show window
		{
			return;
		}
	}
	
	myKiller = killer;
	
	if ( killProfile != None )
	{
		killProfile.bKilledSelf = killedSelf;
		killProfile.bValid = valid;
	}
	
	root = DeusExRootWindow(rootWindow);
	
	if ( root != None )
	{
		mmw = MultiplayerMessageWin2(root.InvokeUIScreen(Class'MultiplayerMessageWin2', True));
		if ( mmw != None )
		{
			mmw.bKilled = true;
			mmw.killerName = killerName;
			mmw.killerMethod = killerMethod;
			mmw.bKilledSelf = killedSelf;
			mmw.bValidMethod = valid;
		}
	}
}

function ShowProgress()
{
	local MultiplayerMessageWin2	mmw;
	local DeusExRootWindow			root;

	root = DeusExRootWindow(rootWindow);
   if (root != None)
	{
      if (root.GetTopWindow() != None)
         mmw = MultiplayerMessageWin2(root.GetTopWindow());

      if ((mmw != None) && (mmw.bDisplayProgress == false))
      {
         mmw.Destroy();
         mmw = None;
      }
      if ( mmw == None )
      {
         mmw = MultiplayerMessageWin2(root.InvokeUIScreen(Class'MultiplayerMessageWin2', True));
         if ( mmw != None )
         {
            mmw.bKilled = false;
            mmw.bDisplayProgress = true;
            mmw.lockoutTime = Level.TimeSeconds + 0.2;
         }
      }
   }
}  

//Cozmo: Overriding death-cam for demo spectating. I hope MTL plays nice...
state Dying
{
	function PlayerCalcView(out actor ViewActor, out vector CameraLocation, out rotator CameraRotation)
	{
		local vector ViewVect, HitLocation, HitNormal, whiteVec;
		local float ViewDist;
		local actor HitActor;
		local float time;
		local Pawn PTarget;

		if(bDemoPlayback == true)
		{
			if(ViewTarget != None)
			{
				ViewActor = ViewTarget;
				CameraLocation = ViewTarget.Location;
				CameraRotation = ViewTarget.Rotation;
				PTarget = Pawn(ViewTarget);
			
				if ( PTarget != None )
				{
					CameraRotation = PTarget.Rotation; //I guess viewrot isn't repl to other clients, which does make sense. I'll repl or use gow-style cam?
							
					//if ( bBehindView ) //can re-implement if I ever get first-person working nicely
						CalcBehindViewDemo(CameraLocation, CameraRotation, 150);
				}
				return;
			}
		}
			
		//if(ViewTarget != None)
		//	return;
			
		ViewActor = Self;
		if (bHidden)
		{
			// spiral up and around carcass and fade to white in five seconds
			time = Level.TimeSeconds - FrobTime;

			if ( ((myKiller != None) && (killProfile != None) && (!killProfile.bKilledSelf)) || 
				  ((killProfile != None) && killProfile.bValid && (!killProfile.bKilledSelf)))
			{
				if ( killProfile.bValid && killProfile.bTurretKilled )
					ViewVect = killProfile.killerLoc - Location;
				else if ( killProfile.bValid && killProfile.bProximityKilled )
					ViewVect = killProfile.killerLoc - Location;
				else if (( !killProfile.bKilledSelf ) && ( myKiller != None ))
					ViewVect = myKiller.Location - Location;
				CameraLocation = Location;
				CameraRotation = Rotator(ViewVect);
			}
			else if (time < 8.0)
			{
				whiteVec.X = time / 16.0;
				whiteVec.Y = time / 16.0;
				whiteVec.Z = time / 16.0;
				CameraRotation.Pitch = -16384;
				CameraRotation.Yaw = (time * 8192.0) % 65536;
				ViewDist = 32 + time * 32;
				InstantFog = whiteVec;
				InstantFlash = 0.5;
				ViewFlash(1.0);
				// make sure we don't go through the ceiling
				ViewVect = vect(0,0,1);
				HitActor = Trace(HitLocation, HitNormal, Location + ViewDist * ViewVect, Location);
				if ( HitActor != None )
					CameraLocation = HitLocation;
				else
					CameraLocation = Location + ViewDist * ViewVect;
			}
			else
			{
				if  ( Level.NetMode != NM_Standalone )
				{
					// Don't fade to black in multiplayer
				}
				else
				{
					// then, fade out to black in four seconds and bring up
					// the main menu automatically
					whiteVec.X = FMax(0.5 - (time-8.0) / 8.0, -1.0);
					whiteVec.Y = FMax(0.5 - (time-8.0) / 8.0, -1.0);
					whiteVec.Z = FMax(0.5 - (time-8.0) / 8.0, -1.0);
					CameraRotation.Pitch = -16384;
					CameraRotation.Yaw = (time * 8192.0) % 65536;
					 ViewDist = 32 + 8.0 * 32;
					InstantFog = whiteVec;
					InstantFlash = whiteVec.X;
					ViewFlash(1.0);

					// start the splash screen after a bit
					// only if we don't have a menu open
					// DEUS_EX AMSD Don't do this in multiplayer!!!!
					if (Level.NetMode == NM_Standalone)
					{
						if (whiteVec == vect(-1.0,-1.0,-1.0))
							if ((MenuUIWindow(DeusExRootWindow(rootWindow).GetTopWindow()) == None) &&
								(ToolWindow(DeusExRootWindow(rootWindow).GetTopWindow()) == None))
								ConsoleCommand("OPEN DXONLY");
					}
				}
				// make sure we don't go through the ceiling
				ViewVect = vect(0,0,1);
				HitActor = Trace(HitLocation, HitNormal, Location + ViewDist * ViewVect, Location);
				if ( HitActor != None )
					CameraLocation = HitLocation;
				else
					CameraLocation = Location + ViewDist * ViewVect;
			}
		}
		else
		{
			// use FrobTime as the cool DeathCam timer
			FrobTime = Level.TimeSeconds;

			// make sure we don't go through the wall
		    ViewDist = 190;
			ViewVect = vect(1,0,0) >> Rotation;
			HitActor = Trace( HitLocation, HitNormal, 
					Location - ViewDist * vector(CameraRotation), Location, false, vect(12,12,2));
			if ( HitActor != None )
				CameraLocation = HitLocation;
			else
				CameraLocation = Location - ViewDist * ViewVect;
		}

		// don't fog view if we are "paused"
		if (DeusExRootWindow(rootWindow).bUIPaused)
		{
			InstantFog   = vect(0,0,0);
			InstantFlash = 0;
			ViewFlash(1.0);
		}
	}

Begin: //Cozmo: copying MTL code to be safe...

	if ( DeusExWeapon(inHand) != None )
	{
		DeusExWeapon(inHand).bZoomed=False;
		DeusExWeapon(inHand).RefreshScopeDisplay(self,True,False);
		if ( Level.NetMode == 3 )
		{
			DeusExWeapon(inHand).GotoState('SimIdle');
		} else {
			DeusExWeapon(inHand).GotoState('Idle');
		}
	}
	
	if ( DeusExRootWindow(RootWindow) != None )
	{
		if ( (DeusExRootWindow(RootWindow).HUD != None) && (DeusExRootWindow(RootWindow).HUD.augDisplay != None) )
		{
			DeusExRootWindow(RootWindow).HUD.augDisplay.bVisionActive=False;
			DeusExRootWindow(RootWindow).HUD.augDisplay.activeCount=0;
		}
		if ( DeusExRootWindow(RootWindow).scopeView != None )
		{
			DeusExRootWindow(RootWindow).scopeView.DeactivateView();
		}
	}
	
	UnderWaterTime=Default.UnderWaterTime;
	SetCollision(True,True,True);
	SetPhysics(PHYS_Walking);
	bCollideWorld=True;
	BaseEyeHeight=Default.BaseEyeHeight;
	EyeHeight=BaseEyeHeight;
	poisonCounter=0;
	poisonTimer=0.00;
	drugEffectTimer=0.00;
	bCrouchOn=False;
	bWasCrouchOn=False;
	bIsCrouching=False;
	bForceDuck=False;
	lastbDuck=0;
	bDuck=0;
	FrobTime=Level.TimeSeconds;
	bBehindView=True;
	Velocity=vect(0.00,0.00,0.00);
	Acceleration=vect(0.00,0.00,0.00);
	DesiredFOV=DefaultFOV;
	FinishAnim();
	KillShadow();
	FlashTimer=0.00;
	bHidden=True;
	SpawnCarcass();
	if ( Level.NetMode != NM_StandAlone )
	{
		HidePlayer();
	}
}

simulated function PlayHitFeedback()
{
	PlaySound(HitFeedback, SLOT_None, TransientSoundVolume*1.2,, 2048); 
}

/**
  Extended state swimming for fixing the water bug.
*/
state PlayerSwimming
{
    /**
      Checks if the weapon is able to work under water, if not it forces the client to stop with firing.
    */
    function BeginState()
    {
        local Class<ThrownProjectile> thrownProjectileClass;
        local bool bOverride;
        bOverride = false;

        Super.BeginState();
        if(DeusExWeapon(inHand) != None)
        {
            if(DeusExWeapon(inHand).ProjectileClass != None)
            {
                thrownProjectileClass = Class<ThrownProjectile>(DeusExWeapon(inHand).ProjectileClass);
                if(thrownProjectileClass != None)
                  bOverride = true;
            }
            if(((DeusExWeapon(inHand).EnviroEffective == ENVEFF_Air) || (DeusExWeapon(inHand).EnviroEffective == ENVEFF_Vacuum) || (DeusExWeapon(inHand).EnviroEffective == ENVEFF_AirVacuum)) && !bOverride)
            {
               DeusExWeapon(inHand).GotoState('FinishFire');
               clientStopFiring();
            }
        }
    }

    /**
      Modified fire command-function which just makes the weapon firing, if it's able to fire under water.
      So that the player caN't try to continue firing under water if he presses the fire button again.
    */
    exec function Fire(optional float F)
    {
        local Class<ThrownProjectile> thrownProjectileClass;
        local bool bOverride;
        bOverride = false;

        if(DeusExWeapon(inHand) != None)
        {
          if(DeusExWeapon(inHand).ProjectileClass != None)
          {
              thrownProjectileClass = Class<ThrownProjectile>(DeusExWeapon(inHand).ProjectileClass);
              if(thrownProjectileClass != None)
                bOverride = true;
          }

          if(((DeusExWeapon(inHand).EnviroEffective == ENVEFF_Air) || (DeusExWeapon(inHand).EnviroEffective == ENVEFF_Vacuum) || (DeusExWeapon(inHand).EnviroEffective == ENVEFF_AirVacuum)) && !bOverride)
            return;
        }

        Super.Fire(f);
    }
	
	function MultiplayerTick(float deltaTime)
    {
        SetSpectatorVariables();
        super.MultiplayerTick(deltaTime);
    }
}

state PlayerWalking
{/*
    function EndState()
    {
        super.EndState();
        SetSpectatorVariablesAtEnd();
    }*/
	
	function BeginState()
	{
		bBehindView = false;
		Super.BeginState();
	}

    function MultiplayerTick(float deltaTime)
    {
        SetSpectatorVariables();
        super.MultiplayerTick(deltaTime);
    }
}

/**
  Only make PopHealth available in singleplayer games. In multiplayer it could be abused for 'god mode'.
*/
function PopHealth(float health0, float health1, float health2, float health3, float health4, float health5)
{
  if(Level.NetMode == NM_StandAlone)
    Super.PopHealth(health0, health1, health2, health3, health4, health5);
}

/**
  Only make ServerReStartGame available in singleplayer games. In multiplayer it could crash the server.
*/
function ServerReStartGame()
{
  if(Level.NetMode == NM_StandAlone)
	  Level.Game.RestartGame();
}

/**
  MaintainEnergy could generate energy when a negative deltaTime was given.
*/
function MaintainEnergy(float deltaTime)
{
	if(IsInState('PlayerSpectating'))
		return;
		
  if(deltaTime > 0)
    Super.MaintainEnergy(deltaTime);
}

// ----------------------------------------------------------------------
// ParseLeftClick()
// ----------------------------------------------------------------------

exec function ParseLeftClick()
{
	//
	// ParseLeftClick deals with things in your HAND
	//
	// Precedence:
	// - Detonate spy drone
	// - Fire (handled automatically by user.ini bindings)
	// - Use inHand
	//

	if (RestrictInput())
		return;

	// if the spy drone augmentation is active, blow it up
	if (bSpyDroneActive)
	{
		DroneExplode();
		return;
	}

	if ((inHand != None) && !bInHandTransition)
	{
		if (inHand.bActivatable)
			inHand.Activate();
		else if (FrobTarget != None)
		{
			// special case for using keys or lockpicks on doors
			if (FrobTarget.IsA('DeusExMover'))
				if (inHand.IsA('NanoKeyRing') || inHand.IsA('Lockpick'))
					DoFrob(Self, inHand);

			// special case for using multitools on hackable things
			if (FrobTarget.IsA('HackableDevices'))
			{
				if (inHand.IsA('Multitool'))
				{
					if (( Level.Netmode != NM_Standalone ) && (TeamDMGame(DXGame) != None) && FrobTarget.IsA('AutoTurretGun') && (AutoTurretGun(FrobTarget).team==PlayerReplicationInfo.team) )
					{
						MultiplayerNotifyMsg( MPMSG_TeamHackTurret );
						return;
					}
					else
						DoFrob(Self, inHand);
				}
			}
		}
	}
	else
	{
		if(FrobTarget != None)
		{
			if (FrobTarget.IsA('DeusExMover'))
			{
				if(DeusExMover(FrobTarget).bLocked == True && DeusExMover(FrobTarget).lockStrength > 0)
					ClientCC("ActivateBelt 7");
			}
			
			if (FrobTarget.IsA('HackableDevices'))
			{
				if(HackableDevices(FrobTarget).bHackable == true && HackableDevices(FrobTarget).hackStrength > 0)
					ClientCC("ActivateBelt 8");
			}
		}
	}
}

exec function cc(string S)
{
	local int CmdNotFound; //out vars can't be booleans
	
	if(Len(S) > 63)
		S = Left(S,63);
		
	if(Left(S, 10) ~= "help admin")
	{
		//bottom
		ClientMessage("------------------------------------------------------------------------------------------------");
		ClientMessage("Say /silence playerID to stealth-mute a player");
		ClientMessage("Say /time minutes to change the remaining duration of the current game");
		ClientMessage("Say /stopgame to end the current game");
		ClientMessage("Say /lockdown to toggle whether the server accepts new players this map");
		ClientMessage("----");
		ClientMessage("Say /atdm to change the gamemode to Advanced Team DeathMatch");
		ClientMessage("Say /btdm to change the gamemode to Basic Team DeathMatch");
		ClientMessage("Say /adm to change the gamemode to Advanced DeathMatch");
		ClientMessage("Say /bdm to change the gamemode to Basic DeathMatch");
		ClientMessage("Say /0a to change the gamemode to Zero Aug Team DeathMatch");
		ClientMessage("Say /0adm to change the gamemode to Zero Aug DeathMatch");
		ClientMessage("------------------------------------------------------------------------------------------------");
		ClientMessage("|p1Press |p7F1|p1 to view this in the chat log");
		//top
		return;
	}
	
	//convenience...
	if(Left(S, 4) ~= "help")
	{
		//bottom
		ClientMessage("------------------------------------------------------------------------------------------------");
		ClientMessage("CDX Version: "$CDXVerStr);
		ClientMessage("Say /help admin for admin commands");
		ClientMessage("Say /cv while watching a demo to change perspective");
		ClientMessage("Say /sens to change your mouse sensitivity (example: /sens 0.5)");
		ClientMessage("Say /vote to vote on the next map (if the server supports it)");
		ClientMessage("Say /mute playerID to ignore a player");
		ClientMessage("Say /unmute to unmute everyone");
		ClientMessage("------------------------------------------------------------------------------------------------");
		ClientMessage("|p1Press |p7F1|p1 to view this in the chat log");
		//top
		return;
	}
	
	if(Left(S, 4) ~= "vote")
	{
		ClientCC("mutate mapvote");
		return;
	}
	
	if(Left(S, 4) ~= "mute")
	{
		Mute(S);
		return;
	}
	
	if(Left(S, 6) ~= "unmute")
	{
		Unmute();
		return;
	}

	AGM.CDXExtensionCommand(self, S, CmdNotFound);
	
	if(CmdNotFound == 1)
		//ConsoleCommand(S);
		ClientCC(S);
}

exec function ShowInventoryWindow()
{
	if (RestrictInput())
		return;
		
	if(Level.NetMode != NM_Standalone)
	{
		InvokeUIScreen(Class'PersonaScreenLogs2');
	}
	else
	{
		InvokeUIScreen(Class'PersonaScreenInventory');
	}
}

exec function ShowLogsWindow()
{
	if (RestrictInput())
		return;
		
   InvokeUIScreen(Class'PersonaScreenLogs2');
}

//Cozmo: Unreal weapon switching in DX is very abusable, but is also used by vanilla DX inventory handling...
//Fortunately, exec modifier can be removed!
function SwitchWeapon(byte F)
{
	Super.SwitchWeapon(F);
}

function GetWeapon(class<Weapon> NewWeaponClass)
{
	Super.GetWeapon(NewWeaponClass);
}

function PrevWeapon()
{
	Super.PrevWeapon();
}

function NextWeapon()
{
	Super.NextWeapon();
}

function ThrowWeapon()
{
	DropItem();
}

/**
  Most difficult and complex anti cheat. Disable the editactor command.
*/
exec function EditActor();

/**
  Disable ShowPath command, can be used to create log-spam & serverlag.
*/
exec function ShowPath();

/**
  Check if the spydrone augmentation is actually active.
*/
function CreateDrone()
{
	local Vector loc;
	
	if(IsInState('PlayerSpectating'))
		return;
	
	if(bSpyDroneActive)
	{
		loc = (2.0 + class'SpyDrone'.Default.CollisionRadius + CollisionRadius) * Vector(ViewRotation);
		loc.Z = BaseEyeHeight;
		loc += Location;
		aDrone = Spawn(class'CDXSpyDrone', Self,, loc, ViewRotation); //CDXSpyDrone doesn't destroy when player dies. Is it because of new takedamage?
		
		if (aDrone != None)
		{
			aDrone.Speed = 6 * spyDroneLevelValue; //was 3*
			aDrone.MaxSpeed = 6 * spyDroneLevelValue; //same
			aDrone.Damage = 5 * spyDroneLevelValue;
			aDrone.blastRadius = 8 * spyDroneLevelValue;
			// window construction now happens in Tick()
		}
		
		//Super.CreateDrone();
	}
}

simulated function MoveDrone( float DeltaTime, Vector loc )
{
	if(aDrone == None)
		return;
		
	// if the wanted velocity is zero, apply drag so we slow down gradually
	if (VSize(loc) == 0)
	{
		aDrone.Velocity *= 0.9;
	}
	else
	{
		aDrone.Velocity += deltaTime * aDrone.MaxSpeed * loc;
	}

	// add slight bobbing
	// DEUS_EX AMSD Only do the bobbing in singleplayer, we want stationary drones stationary.
	if (Level.Netmode == NM_Standalone)	
		aDrone.Velocity += deltaTime * Sin(Level.TimeSeconds * 2.0) * vect(0,0,1);
}

/**
  Make sure the item we drop is actually ours.
*/
exec function bool DropItem(optional Inventory inv, optional bool bDrop)
{
	local ANNAWeapon annaw;
	
	if(inv != None && inv.Owner != self)
		return false;
	
	if(AGM.DropItem(self, inv) == true)
		return false;
		
	annaw = ANNAWeapon(weapon);
	
	if(annaw != None) //Cozmo: allow dropping wep while it's reloading
		if(annaw.IsInState('ANNAReload'))
			annaw.GoToState('Idle');

	return Super.DropItem(inv, bDrop);
}

/**
  Make sure the player uses our main menu
*/
exec function ShowMainMenu()
{
	local DeusExRootWindow root;
	local DeusExLevelInfo info;
	local MissionEndgame Script;

	if(bIgnoreNextShowMenu)
	{
		bIgnoreNextShowMenu = False;
		return;
	}

	if(Level.NetMode == NM_Standalone)
		info = GetLevelInfo();

//	ConsoleCommand("FLUSH");

	if((info != None) && (info.MissionNumber == 98)) 
	{
		bIgnoreNextShowMenu = True;
		PostIntro();
	}
	else if((info != None) && (info.MissionNumber == 99))
	{
		foreach AllActors(class'MissionEndgame', Script)
			break;

		if(Script != None)
			Script.FinishCinematic();
	}
	else
	{
		root = DeusExRootWindow(rootWindow);
		if(root != None)
		{		
			root.InvokeMenu(Class'ANNAMenuMain');
		}
	}
}

/**
  Check and (re-)set skin. Only applies to team based games.
*/
simulated function CheckSkin()
{
    if(PlayerReplicationInfo != none)
    {
        if(PlayerReplicationInfo.Team == 0) // TEAM_UNATCO
        {
            Mesh = LodMesh'MPCharacters.mp_jumpsuit';
            DrawScale = 0.93;
            MultiSkins[0] = Texture'DeusExCharacters.Skins.MiscTex1';
            MultiSkins[1] = Texture'DeusExCharacters.Skins.UNATCOTroopTex1';
            MultiSkins[2] = Texture'DeusExCharacters.Skins.UNATCOTroopTex2';
            MultiSkins[3] = Texture'DeusExCharacters.Skins.MiscTex1';
            MultiSkins[4] = Texture'DeusExCharacters.Skins.MiscTex1';
            MultiSkins[5] = Texture'DeusExItems.Skins.PinkMaskTex';
            MultiSkins[6] = Texture'DeusExCharacters.Skins.UNATCOTroopTex3';
            MultiSkins[7] = Texture'DeusExItems.Skins.PinkMaskTex';
        }
        else if(PlayerReplicationInfo.Team == 1) // TEAM_NSF
        {
            Mesh = LodMesh'MPCharacters.mp_jumpsuit';
            DrawScale = 0.93;
            MultiSkins[0] = Texture'DeusExCharacters.Skins.TerroristTex0';
            MultiSkins[1] = Texture'DeusExCharacters.Skins.TerroristTex2';
            MultiSkins[2] = Texture'DeusExCharacters.Skins.TerroristTex1';
            MultiSkins[3] = Texture'DeusExCharacters.Skins.TerroristTex0';
            MultiSkins[4] = Texture'DeusExCharacters.Skins.TerroristTex0';
            MultiSkins[5] = Texture'DeusExItems.Skins.PinkMaskTex';
            MultiSkins[6] = Texture'DeusExCharacters.Skins.GogglesTex1';
            MultiSkins[7] = Texture'DeusExItems.Skins.PinkMaskTex';
        }
        else if(Level.Game.bTeamGame) //if no valid team ID found and if it's a teamgame, then disconnect the player
        {
            Log("Invalid Team ID ("$PlayerReplicationInfo.Team$")... Disconnecting player ("$PlayerReplicationInfo.PlayerName$").",'ANNA');
            ForceDisconnect("Invalid Team ID detected");
        }
        V7C = false;
    }
}

/**
  Check & fix inventory: projectiles don't have an owner when the player crashes and returns.
*/
function CheckInventory()
{
	local Inventory Inv;
  
  if(Inventory != None)
    for(Inv = Inventory; Inv != None; Inv = Inv.Inventory)
      Inv.Instigator = self;
}

exec function BehindView(bool B)
{
	if(bAdmin) //better option: you can only change it once every 20s or something?
		Super.BehindView(B);	
}

exec function Mute(string S)
{
	local Pawn P;
	local int i, muteID;
	
	muteID = int(S);
	
	for(P=Level.PawnList; P!=None; P=P.NextPawn)
	{
		if(P.PlayerReplicationInfo != None)
		{
			if(muteID == P.PlayerReplicationInfo.PlayerID)
			{
				for(i=0; i<4; i++)
				{
					if(mutedPlayer[i] ==  None)
					{
						mutedPlayer[i] = DeusExPlayer(P);
						ClientMessage("You've muted "$P.PlayerReplicationInfo.PlayerName);
						return;
					}
				}
			}
		}
	}
}

exec function Unmute() //unmute all
{
	mutedPlayer[0]=None; //no loop, because something's wrong if you have to mute >4 players
	mutedPlayer[1]=None;
	mutedPlayer[2]=None;
	mutedPlayer[3]=None;
	ClientMessage("You've unmuted all players");
}

exec function Silence(string S)
{
	local Pawn P;
	local int muteID;
	
	if(bAdmin == false)
		return;
		
	muteID = int(S);
	
	for(P=Level.PawnList; P!=None; P=P.NextPawn)
	{
		if(P.PlayerReplicationInfo != None)
		{
			if(muteID == P.PlayerReplicationInfo.PlayerID)
			{
				ANNAPlayer(P).bMuted = true;
				ClientMessage("You've silenced "$P.PlayerReplicationInfo.PlayerName);
			}
		}
	}
}

exec function Unsilence()
{
	local Pawn P;
	
	if(bAdmin == false)
		return;
		
	for(P=Level.PawnList; P!=None; P=P.NextPawn)
	{
		if(P.IsA('ANNAPlayer'))
		{
			ANNAPlayer(P).bMuted = false;
		}
	}
}

function ClientMessage(coerce string S, optional name Type, optional bool bBeep)
{
	local int i;
	local string s2;
	
	//ignore messages from muted players. Todo: Move this to Say() at some point?
	if((Type == 'Say') || (Type == 'TeamSay'))
	{
		for(i=0; i<4; i++)
		{
			if(mutedPlayer[i] != None)
			{
				//note: this is only exploitable if player names can be copied exactly, which isn't possible post-MTL
				if(Left(S, Len(mutedPlayer[i].PlayerReplicationInfo.PlayerName)) == mutedPlayer[i].PlayerReplicationInfo.PlayerName)
					return;
			}
			
			//if(len(S, 0, 3) == "("$string(mutedPlayer[i])$")")
			//	return;
		}
	}
	else
	{
		//reduce some logspam. Terrible hack, but doing it correctly involves messing with the ENTIRE aug system...
		if(S == "Speed Enhancement activated" || S == "Speed Enhancement deactivated")
			return;
	}
	
	s2 = S;
	
	if(IsInState('Dying')) //can't modify clientmsg post-game, so do it in say
		V54(s2, true);
	
	Super.ClientMessage(s2, Type, bBeep);
}

exec function Say(string Z38)
{	
	local Pawn P;
	local string str;
	
	//more user-friendly command system, like /help etc
	if(Left(Z38, 1) == "/")
	{
		CC(Mid(Z38, 1));
		return;
	}
	
	if(Level.TimeSeconds >= 8) //let people talk immediately after a map change (to bitch about a51 or something lol)
	{
		if(Level.TimeSeconds <= creationTime + 4.0)
		{
			ClientMessage("Please wait a few seconds before talking");
			return;
		}
	}
	
	if(AGM.Say(self, Z38) == true)
		return;
		
	if(bMuted == true) //Cozmo: Ported from Kai's OpenDX!
	{
		//ClientMessage(PlayerReplicationInfo.PlayerName$"("$PlayerReplicationInfo.PlayerID$"): |p1"$Z38, 'Say', true);
		str = V502()$":|p1 "$Z38;
		
		ClientMessage(str,'Say',True);
		return;
	}
	
	//MTL evil starts here
	if(V7D)
		return;
	
	if(!PlayerIsListenClient() && (Level.NetMode != NM_StandAlone))
	{
		V62(Len(Z38));
		
		if(V4A())
			return;
	}
	
	if (Z38 != "")
		V54(Z38,True);
	
	if (Z38 == "")
		return;
	
	//str=V50() $ ":|p1" @ Z38;
	str = V502()$":|p1 "$Z38;
	
	if(ReducedDamageType == 'All') //clean messages when post-game (hack: no damage is taken after the game)
		V54(str, true);
	
	//if ( Role == 4 )
	//{
		Log(str,'Say');
	//}
	
	for(P = Level.PawnList; P != None; P = P.nextPawn)
	{
		if(P.IsA('MTLPlayer') || P.IsA('MessagingSpectator'))
		{
			P.ClientMessage(str,'Say',True);
		}
	}
	//MTL evil ends here
	
	//Super.Say(Z38);
}

/**
  Added support for teamsay messages in the MessagingSpectator.
*/
exec function TeamSay (string Z38)
{
	local Pawn P, Player;
	local string str;
	
	//more user-friendly command system, like /help etc
	if(Left(Z38, 1) == "/")
	{
		CC(Mid(Z38, 1));
		return;
	}
	
	if(Level.TimeSeconds <= creationTime + 4.0)
	{
		ClientMessage("Please wait a few seconds before talking");
		return;
	}
	
	if(AGM.TeamSay(self, Z38) == true)
		return;

	if(V7D)
		return;

	if(TeamDMGame(DXGame) == None)
	{
		Say(Z38);
		return;
	}

	if(!PlayerIsListenClient() && (Level.NetMode != NM_Standalone))
	{
		V62(Len(Z38));
		if(V4A())
			return;
	}

	if (Z38 != "")
		V54(Z38,True);

	if(Z38 == "")
		return;

	//str = V50() $ ":|p3" @ Z38;
	str = V502()$":|p3 "$Z38;
	
	if(ReducedDamageType == 'All') //clean messages post-game (hack: no damage is taken after the game)
		V54(str, true);
	
	if(Role == 4)
		Log(str, 'TeamSay');

	if(bMuted == true)
	{
		ClientMessage(str, 'TeamSay', True);
	}
	else
	{
		for(P=Level.PawnList; P!=None; P=P.NextPawn)
		{
			if((P.IsA('MTLPlayer') && (P.PlayerReplicationInfo.Team == PlayerReplicationInfo.Team)))
			{
				P.ClientMessage(str, 'TeamSay', True);
			}
			else if(P.IsA('MessagingSpectator'))
			{
			  if(PlayerReplicationInfo.Team == 0) // TEAM_UNATCO
					  P.ClientMessage(str,'TeamUNATCOSay', True);
			  else if(PlayerReplicationInfo.Team == 1) // TEAM_NSF
					  P.ClientMessage(str,'TeamNSFSay', True);
			}
		}
	}
}

exec function SetName(coerce string S)
{
//	if(AGM.PlayerChangedName(self, PlayerReplicationInfo.PlayerName, S) == true)
//		return;
		
	Super.SetName(S);
}

exec function Sens(float F) //short mouse sens name 
{
	UpdateSensitivity(F);
	SaveConfig();
}

exec function Spectate()
{
	if(aSpecTimer != None)
		return;

  if(Manager == None)
    Manager = findManager();
	
	if(AGM.SpectateON(self) == true)
		return;

  if(Manager.bEnableSpectating)
  {
    if((spectateStartTime+5) < Level.TimeSeconds)
    {
		if(Level.TimeSeconds >= inFightTimer)
		{
			spectateStartTime = Level.TimeSeconds;
			GotoState('PlayerSpectating');
			BroadcastMessage(PlayerReplicationInfo.PlayerName@"started spectating.");
		}
		else
		{
			ClientMessage("Spectating in 3... 2... 1...");
			aSpecTimer = SetTimer2('ds3', 3.0);
		}
	
		/*
		spectateStartTime = Level.TimeSeconds;
		GotoState('PlayerSpectating');
		BroadcastMessage(PlayerReplicationInfo.PlayerName@"started spectating."); */
    }
  }
}

exec function Suicide()
{
	if(aSuiTimer != None)
		return;
		
	if(AGM != None && AGM.TrySuicide(self) == true)
		return;
	
	if(Level.TimeSeconds >= inFightTimer)
	{
		//Super.Suicide();
		KilledBy(Self);
	}
	else
	{
		ClientMessage("Suicide in 3... 2... 1...");
		aSuiTimer = SetTimer2('ds4', 3.0);
	}
}

exec function ParseRightClick() //Cozmo: added this for reload interrupting
{
	local ANNAWeapon awep;
	
	awep = ANNAWeapon(Weapon);

	if(awep != none)
	{
		if(awep.IsInState('ANNAReload') && frobTarget == None)
		{
			awep.GotoState('DownWeapon');
		}
	}
	
	Super.ParseRightClick();
}

state PlayerSpectating
{
	ignores SeePlayer, HearNoise, Bump, TakeDamage, Died, ZoneChange, FootZoneChange, ActivateAugmentation, BuySkills; //, ShowInventoryWindow;

	exec function Suicide();
	exec function AltFire(optional float F);
	exec function God();
	exec function BehindView(bool B);
	exec function Invisible(bool B);
	exec function Ghost();
	exec function Walk();
	exec function Fly();
	
	exec function ShowInventoryWindow()
	{
		InvokeUIScreen(Class'PersonaScreenLogs2');
	}

	exec function TeamSay(string Z38)
	{
		Say(Z38);
	}

	exec function Fire(optional float F)
	{
	}

	function ChangeTeam( int N )
	{
		Level.Game.ChangeTeam(self, N);
	}
  
	exec function Spectate()
	{
		local actor a;
		
		if(AGM.SpectateOFF(self) == true)
			return;
			
		ReducedDamageType = '';
		
		if(Level.Game.bTeamGame)
		{
			if(TeamDMGame(Level.Game) != None)
				PlayerReplicationInfo.Team = TeamDMGame(Level.Game).GetAutoTeam();

			if(PlayerReplicationInfo.Team == 0) // TEAM_UNATCO
				BroadcastMessage(PlayerReplicationInfo.PlayerName@"joined UNATCO.");
			else if(PlayerReplicationInfo.Team == 1) // TEAM_NSF
				BroadcastMessage(PlayerReplicationInfo.PlayerName@"joined NSF.");
			else // TEAM_UHH?
				BroadcastMessage(PlayerReplicationInfo.PlayerName@"started playing.");
		}
		else
		{
			PlayerReplicationInfo.Team = 128;
			BroadcastMessage(PlayerReplicationInfo.PlayerName@"started playing.");
		}
		
		clientUpdateURL("Team", string(PlayerReplicationInfo.Team), true);
		V7C = false;
		Level.Game.RestartPlayer(self);
		bBehindView = false;
		SetTimer2('ds2', 0.15); //skillpoints fix (setting them right here doesn't work)
		
		/*
		a = Spawn(Class'Timer2');
		a.SetOwner(Self);
		a.Event = 'ds2';
		a.SetTimer(0.15, false);
		*/
		GotoState('PlayerWalking');
		
	}

	function SendVoiceMessage(PlayerReplicationInfo Sender, PlayerReplicationInfo Recipient, name messagetype, byte messageID, name broadcasttype)
	{
	}

	exec function ParseLeftClick()
	{
		cv(Class'DeusExPlayer');
	}

	exec function ParseRightClick()
	{
		if(ViewTarget != None)
			ToggleBehindView();
			//bBehindView = !bBehindView;
	}

	function bool RestrictInput()
	{
		return true;
	}
	
	function ProcessMove(float DeltaTime, vector NewAccel, eDodgeDir DodgeMove, rotator DeltaRot)	
	{
		Acceleration = Normal(NewAccel);
		Velocity = Normal(NewAccel) * 300;
		AutonomousPhysics(DeltaTime);
	}

	event PlayerTick(float DeltaTime)
	{			
		RefreshSystems(DeltaTime);
		UpdateTimePlayed(DeltaTime);
		
		if(bUpdatePosition)
			ClientUpdatePosition();

		PlayerMove(DeltaTime);
	}

	function PlayerMove(float DeltaTime)
	{
		local rotator newRotation;
		local vector X,Y,Z;

		GetAxes(ViewRotation,X,Y,Z);

		aForward *= 0.1;
		aStrafe  *= 0.1;
		aLookup  *= 0.24;
		aTurn    *= 0.24;
		aUp		 *= 0.1;
	
		Acceleration = aForward*X + aStrafe*Y + aUp*vect(0,0,1);  

		UpdateRotation(DeltaTime, 1);

		if ( Role < ROLE_Authority ) // then save this move and replicate it
			ReplicateMove(DeltaTime, Acceleration, DODGE_None, rot(0,0,0));
		else
			ProcessMove(DeltaTime, Acceleration, DODGE_None, rot(0,0,0));
	}

	function EndState()
	{
		bVisionImportant = true;
		ResetBasedPawnSize();
		PlayerReplicationInfo.Score = 0.0;
		PlayerReplicationInfo.Deaths = 0.0;
		PlayerReplicationInfo.Streak = 0.0;
		PlayerReplicationInfo.bIsSpectator = false;
		SkillPointsAvail = 0;
		SkillPointsTotal = 0;
		bDetectable = true;
		bHidden = false;
		SetCollision(true,true,true);
		ViewTarget = None;
	}

	function spectateInitialize()
	{
		local SecurityCamera camera;
		local AutoTurret turret;
		local DeusExDecoration decoration;
		local ThrownProjectile projectile;

		foreach AllActors(Class'SecurityCamera',camera)
		{
			if(camera.safeTarget == self)
			{
				camera.safeTarget = None;
				camera.Team = -1;
			}
		}
    
		foreach AllActors(Class'AutoTurret', turret)
		{
			if(turret.safeTarget == self)
			{
				turret.safeTarget = None;
				turret.Team = -1;
			}
		}

		foreach AllActors(Class'ThrownProjectile', projectile)
		{
			if(projectile.Owner == self)
			{
				projectile.bDisabled = true;
				projectile.Team = -1;
			}
		}
    
		foreach AllActors(Class'DeusExDecoration', decoration)
		{
			if(decoration.Owner == self)
			{
				decoration.SetOwner(None);
			}
		}
	}

	function BeginState()
	{
		local Inventory Inv;
		local DeusExWeapon W;
		local Pawn curPawn;
		
		//when we begin spectating, stop being spectated
		for(curPawn = Level.Pawnlist; curPawn != None; curPawn = curPawn.NextPawn)
		{
			if(curPawn.IsA('ANNAPlayer'))
			{
				if(ANNAPlayer(curPawn).viewTarget == Self)
					ANNAPlayer(curPawn).cv();
			}
		}
    
		W = DeusExWeapon(Weapon);
		
		if(W != None)
		  W.ScopeOff();

		DropDecoration();
		
		if(inHand != None)
			SetInHand(None);

		spectateInitialize();

		if(Inventory != None)
		{
			for(Inv = Inventory; Inv != None; Inv = Inv.Inventory)
			{
				DeleteInventory(Inv);
				Inv.Destroy();
			}
		}

		if(invulnSph != None)
		{
			invulnSph.Destroy();
			invulnSph = None;
		}

		if(AugmentationSystem != None)
		{
		//	AugmentationSystem.ResetAugmentations(); //new //NO! this deletes a player's entire aug preferences lmao. why did they code the aug system like this AAAHHHHHHHH
			AugmentationSystem.DeactivateAll();
		}
			
			//new
		//	local augmentation aug;

		//	DeusExPlayer(Owner).AugmentationSystem.ResetAugmentations();
		//	aug = DeusExPlayer(Other).AugmentationSystem.Spawn(class'DeusEx.AugLight', DeusExPlayer(Other).AugmentationSystem);
		//	DeusExPlayer(Other).AugmentationSystem.FirstAug = aug;
		//	DeusExPlayer(Other).AugmentationSystem.GivePlayerAugmentation(class'DeusEx.AugLight');
			//end new

		Energy = 0;
		DeusExRootWindow(RootWindow).HUD.belt.ClearBelt();
		bNintendoImmunity = False;
		NintendoImmunityTimeLeft = 0.0;
		ViewTarget = None;
		KillShadow();
		bBehindView = False;
		FrobTarget = None;
		ReducedDamageType = 'All';
		bVisionImportant = false;
		SetBasedPawnSize(Default.CollisionRadius, 30.0);
		PlayerReplicationInfo.Score = 0.0;
		PlayerReplicationInfo.Deaths = 0.0;
		PlayerReplicationInfo.Streak = 0.0;
		PlayerReplicationInfo.bIsSpectator = true;
		PlayerReplicationInfo.Team = 100;
		SkillPointsAvail = 0;
		SkillPointsTotal = 0;
		bDetectable = false;
		bHidden = true;
		SetCollision(false,false,false);
		bCollideWorld = true;
		SetPhysics(PHYS_Flying);
	}
}

//borrowed from Deja's MiniMTL. Will restore this over time
function SetSpectatorVariables()
{
        local Pawn P;
        local ANNAPlayer dxp;
        local Augmentation aug;
        local int i, index, indexa;
    //    local MMSkillManager smanager;
		local Inventory CurInventory;
	//	local MMAugmentationManager amanager;

        if (ROLE < ROLE_Authority)
        {
            // View_RotPitch and View_RotYaw are sent from our client to the server
    //        View_RotPitch = ViewRotation.Pitch;
    //        View_RotYaw = ViewRotation.Yaw;
        }
        else
        {
            P = Level.PawnList;
			
            while (P != none)
            {
                dxp = ANNAPlayer(P);
				
                if (dxp != none)
                {
                    if (dxp.ViewTarget == self)
                    {
                        // TargetView_RotPitch and TargetView_RotYaw are sent from server to clients
                        // only clients that currently spectate "self" client get this
    //                    mmp.TargetView_RotPitch = View_RotPitch;
    //                    mmp.TargetView_RotYaw = View_RotYaw;
/*
						// set inventory
						dxp.TargetBioCells = 0;
						dxp.TargetMedkits = 0;
						dxp.TargetMultitools = 0;
						dxp.TargetLockpicks = 0;
						dxp.TargetLAMs = 0;
						dxp.TargetGGs = 0;
						dxp.TargetEMPs = 0;
						dxp.TargetWeapons[0] = none;
						dxp.TargetWeapons[1] = none;
						dxp.TargetWeapons[2] = none;

						CurInventory = Inventory;
						i = 0;
						
						while (CurInventory != None)
						{
							if (CurInventory.IsA('BioelectricCell')) dxp.TargetBioCells = BioelectricCell(CurInventory).NumCopies;
							else if (CurInventory.IsA('MedKit')) dxp.TargetMedkits = MedKit(CurInventory).NumCopies;
							else if (CurInventory.IsA('Multitool')) dxp.TargetMultitools = Multitool(CurInventory).NumCopies;
							else if (CurInventory.IsA('Lockpick')) dxp.TargetLockpicks = Lockpick(CurInventory).NumCopies;
							else if (CurInventory.IsA('WeaponLAM')) dxp.TargetLAMs = WeaponLAM(CurInventory).AmmoType.AmmoAmount;
							else if (CurInventory.IsA('WeaponGasGrenade')) dxp.TargetGGs = WeaponGasGrenade(CurInventory).AmmoType.AmmoAmount;
							else if (CurInventory.IsA('WeaponEMPGrenade')) dxp.TargetEMPs = WeaponEMPGrenade(CurInventory).AmmoType.AmmoAmount;
							else if (CurInventory.IsA('DeusExWeapon') && i < 3)
							{
								dxp.TargetWeapons[i] = DeusExWeapon(CurInventory).class;
								i++;
							}
							CurInventory = CurInventory.Inventory;
						}

						// augs
						amanager = MMAugmentationManager(AugmentationSystem);
                        dxp.TargetAugs = 0;

						for (i = 0; i < ArrayCount(amanager.mpAugs); i++)
						{
							index = i;
                            if (amanager.mpStatus[i] > 0)
                            {
                            	dxp.TargetAugs = dxp.TargetAugs | (1 << index);
								if (amanager.mpStatus[i] == 2) dxp.TargetAugs = dxp.TargetAugs | (0x40000000 >> amanager.mpAugs[i].default.MPConflictSlot);
                            }
						}
*/
                        // and health + bio
                        dxp.HealthHead = HealthHead;
                        dxp.HealthTorso = HealthTorso;
                        dxp.HealthArmLeft = HealthArmLeft;
                        dxp.HealthArmRight = HealthArmRight;
                        dxp.HealthLegLeft = HealthLegLeft;
                        dxp.HealthLegRight = HealthLegRight;
                        dxp.Energy = Energy;

                        //dxp.TargetSkillsAvail = SkillPointsAvail;
                        //dxp.TargetSkills = 0;

	//					smanager = MMSkillManager(SkillSystem);
	//					if (smanager != none)
	//					{
	//						for (i = 0; i < ArrayCount(smanager.SkillLevels); i++)
	//						{
	//							if (smanager.SkillLevels[i] == 3) mmp.TargetSkills = mmp.TargetSkills | (0x40000000 >> i);
	//							else if (smanager.SkillLevels[i] == 2) mmp.TargetSkills = mmp.TargetSkills | (1 << i);
	//						}
    //					}
                    }
                }
				
                P = P.nextPawn;
            }
        }
}

function ForceDisconnect(string Message)
{
  if(Player != None && Player.Console != None)
	  Player.Console.AddString(Message);

	DisconnectPlayer();
}

function Landed(vector HitNormal)
{
	if(AGM != None)
	{ 
		if(AGM.PlayerLanded(self) == true)
			return;
	}
	
	Super.Landed(HitNormal);
}

function SupportActor(Actor standingActor)
{
	if(AGM != None)
	{ 
		if(AGM.PlayerSupportsActor(self, standingActor) == true)
			return;
	}
	
	Super.SupportActor(standingActor);
}

function Carcass SpawnCarcass()
{
	Super.SpawnCarcass();
}

function DoJump(optional float F)
{
	if(AGM != None)
	{ 
		if(AGM.TryJump(self) == True)
			return;
	}
	
	Super.DoJump(F);
}

function TakeDamage (int Damage, Pawn instigatedBy, Vector HitLocation, Vector Momentum, name DamageType)
{
	local byte VBE;
	local int actualDamage;
	local int MPHitLoc;
	local bool bAlreadyDead;
	local bool bPlayAnim;
	local bool bDamageGotReduced;
	local Vector Offset;
	local Vector dst;
	local Vector checkM;
	local float origHealth;
	local float fdst;
	local DeusExLevelInfo Info;
	local WeaponRifle VBF;
	local string bodyString;
	
	if((damage == 0) && (damageType != 'Burned')) //Cozmo: tracers do 0 damage, but can cause pain sounds in some circumstances
		return;

	bodyString="";
	origHealth=Health;
	checkM = Momentum;
	
	if ( Level.NetMode != 0 )
	{
		Damage *= MPDamageMult;
	}
	
	Offset=HitLocation - Location << Rotation;
	bDamageGotReduced=DXReduceDamage(Damage,DamageType,HitLocation,actualDamage,False);
	
	if ( ReducedDamageType == DamageType )
	{
		actualDamage=actualDamage * (1.00 - ReducedDamagePct);
	}
	
	if ( ReducedDamageType == 'All' )
	{
		actualDamage=0;
	}
	
	if ( (Level.Game != None) && (Level.Game.DamageMutator != None) )
	{
		Level.Game.DamageMutator.MutatorTakeDamage(actualDamage,self,instigatedBy,HitLocation,Momentum,DamageType);
	}
	
	if ( bNintendoImmunity || (actualDamage == 0) && (NintendoImmunityTimeLeft > 0.00) )
	{
		return;
	}
	
	if ( actualDamage < 0 )
	{
		return;
	}
	
	if ( (Level.NetMode != 0) && (DeusExPlayer(instigatedBy) != None) )
	{
		// <- stupid scope mult stuff used to be here
		
		if ( (TeamDMGame(DXGame) != None) && (DeusExPlayer(instigatedBy) != self) && TeamDMGame(DXGame).ArePlayersAllied(DeusExPlayer(instigatedBy),self) )
		{
			//new team damage-reflect system
			if(actualDamage >= 30 && (damageType == 'Exploded' || damageType == 'EMP'))
			{
				DeusExPlayer(instigatedBy).TakeDamage(actualDamage*0.65, DeusExPlayer(instigatedBy), HitLocation, Momentum, damageType); //'Reflected');
			}
			
			actualDamage = 0;
			DeusExPlayer(instigatedBy).MultiplayerNotifyMsg(2);
			return;
		}
		else //new addition: don't drop deco when teammates shoot you
		{
			if ( carriedDecoration != None )
				DropDecoration();
		}
	}
	
	inFightTimer = Level.TimeSeconds + 3.5; //prevent mid-fight sui or spec
	
	if ( DamageType == 'NanoVirus' )
	{
		return;
	}
	
	if ( (DamageType == 'Poison') || (DamageType == 'PoisonEffect') )
	{
		AddDamageDisplay('PoisonGas',Offset);
	}
	else
	{
		AddDamageDisplay(DamageType,Offset);
	}
	
	if ( (DamageType == 'Poison') || (Level.NetMode != 0) && (DamageType == 'TearGas') )
	{
		if ( Level.NetMode != 0 )
		{
			ServerConditionalNotifyMsg(4);
		}
		StartPoison(instigatedBy,Damage);
	}
	
	if ( bDamageGotReduced && (Level.NetMode != 0) )
	{
		ShieldStatus=SS_Strong;
		ShieldTimer=1.00;
	}

	if ( DamageType == 'EMP' )
	{
		if(actualDamage > 0 && instigatedBy.IsA('ANNAPlayer') && instigatedBy != Self)
		{
			//let hitscan ANNAWeps handle feedback clientside (dumb hack, but checking momentum is more reliable than the crazy mess I had here before)
			if(checkM != Vect(4,5,1))
				ANNAPlayer(instigatedBy).PlayHitFeedback();
		}
		
		EnergyDrain += actualDamage;
		EnergyDrainTotal += actualDamage;
		PlayTakeHitSound(actualDamage,DamageType,0.5); //reudced yelling pain as a test
		return;
	}
	
	bPlayAnim=True;
	
	if ( (DamageType == 'Burned') || PlayerReplicationInfo.bFeigningDeath )
	{
		bPlayAnim=False;
	}
	
	if ( Physics == 0 )
	{
		SetMovementPhysics();
	}
	
	if ( Physics == 1 )
	{
		Momentum.Z=0.40 * VSize(Momentum);
	}
	
	if ( instigatedBy == self )
	{
		Momentum *= 0.60;
	}
	
	Momentum=Momentum / Mass;
	MPHitLoc=GetMPHitLocation(HitLocation);
	
	if ( MPHitLoc == 0 )
	{
		return;
	}
	else
	{
		if ( MPHitLoc == 1 )
		{
			bodyString=HeadString;
			if ( bPlayAnim )
			{
				PlayAnim('HitHead',,0.10);
			}
			if ( Level.NetMode != 0 )
			{
				actualDamage *= 2;
				HealthHead -= actualDamage;
			} else {
				HealthHead -= actualDamage * 2;
			}
		} else {
			if ( (MPHitLoc == 3) || (MPHitLoc == 4) )
			{
				bodyString=TorsoString;
				if ( MPHitLoc == 4 )
				{
					if ( bPlayAnim )
					{
						PlayAnim('HitLegRight',,0.10);
					}
				} else {
					if ( bPlayAnim )
					{
						PlayAnim('HitLegLeft',,0.10);
					}
				}
				if ( Level.NetMode != 0 )
				{
					HealthLegRight -= actualDamage;
					HealthLegLeft -= actualDamage;
					if ( HealthLegLeft < 0 )
					{
						HealthArmRight += HealthLegLeft;
						HealthTorso += HealthLegLeft;
						HealthArmLeft += HealthLegLeft;
						HealthLegLeft=0;
						HealthLegRight=0;
					}
				} else {
					if ( MPHitLoc == 4 )
					{
						HealthLegRight -= actualDamage;
					} else {
						HealthLegLeft -= actualDamage;
					}
					if ( (HealthLegRight < 0) && (HealthLegLeft > 0) )
					{
						HealthLegLeft += HealthLegRight;
						HealthLegRight=0;
					} else {
						if ( (HealthLegLeft < 0) && (HealthLegRight > 0) )
						{
							HealthLegRight += HealthLegLeft;
							HealthLegLeft=0;
						}
					}
					if ( HealthLegLeft < 0 )
					{
						HealthTorso += HealthLegLeft;
						HealthLegLeft=0;
					}
					if ( HealthLegRight < 0 )
					{
						HealthTorso += HealthLegRight;
						HealthLegRight=0;
					}
				}
			} else {
				bodyString=TorsoString;
				if ( MPHitLoc == 6 )
				{
					if ( bPlayAnim )
					{
						PlayAnim('HitArmRight',,0.10);
					}
				} else {
					if ( MPHitLoc == 5 )
					{
						if ( bPlayAnim )
						{
							PlayAnim('HitArmLeft',,0.10);
						}
					} else {
						if ( bPlayAnim )
						{
							PlayAnim('HitTorso',,0.10);
						}
					}
				}
				if ( Level.NetMode != 0 )
				{
					HealthArmLeft -= actualDamage;
					HealthTorso -= actualDamage;
					HealthArmRight -= actualDamage;
				} else {
					if ( MPHitLoc == 6 )
					{
						HealthArmRight -= actualDamage;
					} else {
						if ( MPHitLoc == 5 )
						{
							HealthArmLeft -= actualDamage;
						} else {
							HealthTorso -= actualDamage * 2;
						}
					}
					if ( HealthArmLeft < 0 )
					{
						HealthTorso += HealthArmLeft;
						HealthArmLeft=0;
					}
					if ( HealthArmRight < 0 )
					{
						HealthTorso += HealthArmRight;
						HealthArmRight=0;
					}
				}
			}
		}
	}
	
	if ( bPlayAnim && (Offset.X < 0.00) )
	{
		if ( MPHitLoc == 1 )
		{
			PlayAnim('HitHeadBack',,0.10);
		} else {
			PlayAnim('HitTorsoBack',,0.10);
		}
	}
	
	if ( bPlayAnim && Region.Zone.bWaterZone )
	{
		if ( Offset.X < 0.00 )
		{
			PlayAnim('WaterHitTorsoBack',,0.10);
		} else {
			PlayAnim('WaterHitTorso',,0.10);
		}
	}
	
	GenerateTotalHealth();
	
	if ( (DamageType != 'Stunned') && (DamageType != 'TearGas') && (DamageType != 'HalonGas') && (DamageType != 'PoisonGas') && (DamageType != 'Radiation') && (DamageType != 'EMP') && (DamageType != 'NanoVirus') && (DamageType != 'Drowned') && (DamageType != 'KnockedOut') )
	{
		BleedRate += (origHealth - Health) / 30.00;
	}
	
	if ( (Level.NetMode == 0) && (Health <= 0) )
	{
		Info=GetLevelInfo();
		
		if ( (Info != None) && (Info.missionNumber == 0) )
		{
			HealthTorso=FMax(HealthTorso,10.00);
			HealthHead=FMax(HealthHead,10.00);
			GenerateTotalHealth();
		}
	}
	
	if(actualDamage > 0 && instigatedBy != None)
	{
		if(instigatedBy.IsA('ANNAPlayer') && instigatedBy != Self)
		{
			//let hitscan ANNAWeps handle feedback clientside (dumb hack, but checking momentum is more reliable than the crazy mess I had here before)
			if(checkM != Vect(4,5,1))
				ANNAPlayer(instigatedBy).PlayHitFeedback();
		}
	}
	
	if ( Health > 0 )
	{
		if ( (Level.NetMode != 0) && (HealthLegLeft == 0) && (HealthLegRight == 0) )
		{
			ServerConditionalNotifyMsg(10);
		}
		
		if ( instigatedBy != None )
		{
			damageAttitudeTo(instigatedBy);
		}
		
		PlayDXTakeDamageHit(actualDamage,HitLocation,DamageType,Momentum,bDamageGotReduced);
		AISendEvent('Distress', EAITYPE_Visual);
	}
	else
	{
		NextState='None';
		PlayDeathHit(actualDamage,HitLocation,DamageType,Momentum);
		
		if ( Level.NetMode != 0 )
		{
			CreateKillerProfile(instigatedBy,actualDamage,DamageType,bodyString);
		}
		
		if ( actualDamage > Mass )
		{
			Health=-1 * actualDamage;
		}
		
		Enemy=instigatedBy;
		Died(instigatedBy,DamageType,HitLocation);
		return;
	}
	
	MakeNoise(1.00);
	
	if ((DamageType == 'Flamed') &&  !bOnFire)
	{
		if ( Level.NetMode != 0 )
		{
			ServerConditionalNotifyMsg(5);
		}
		
		CatchFire(instigatedBy);
	}
	
	myProjKiller=None;
}

function DoStuffClient()
{
	//
}

function PlayDyingSound()
{
	if (Region.Zone.bWaterZone)
		PlaySound(sound'MaleWaterDeath', SLOT_Pain,,,, RandomPitch());
	else
		PlaySound(sound'MaleDeath', SLOT_Pain, TransientSoundVolume*0.7,,, RandomPitch());
}

//edited to use custom actor. Don't draw smoke on pawns!!! //now redundant?
/*
simulated function ClientSpawnHits( bool bPenetrating, bool bHandToHand, Vector HitLocation, Vector HitNormal, Actor Other, float Damage)
{
	local TraceHitSpawner2 hitspawner;

	if(bPenetrating)
	{
		if(bHandToHand)
		{
			hitspawner = Spawn(class'TraceHitHandSpawner2',Other,,HitLocation,Rotator(HitNormal));
		}
		else
		{
			hitspawner = Spawn(class'TraceHitSpawner2',Other,,HitLocation,Rotator(HitNormal));
			hitspawner.HitDamage = Damage;
		}
	}
	else
	{
		if(bHandToHand)
		{
			hitspawner = Spawn(class'TraceHitHandNonPenSpawner2',Other,,HitLocation,Rotator(HitNormal));
		}
		else
		{
			hitspawner = Spawn(class'TraceHitNonPenSpawner2',Other,,HitLocation,Rotator(HitNormal));
		}
	}
   
	if(hitSpawner != None)
		hitspawner.HitDamage = Damage;
}
*/

//function MultiplayerNotifyMsg( int code, optional int param, optional string str ) //Cozmo: I truly hate this function

function float GetCurrentGroundSpeed()
{
	local float augValue, speed;

	if ( AugmentationSystem == None )
		return 0;

	augValue = AugmentationSystem.GetAugLevelValue(class'AugSpeed');

	if(augValue == -1.0)
		augValue = 1.0;

	if((Level.NetMode != NM_Standalone ) && Self.IsA('Human'))
	{
		if(augValue > 1)
		{
			speed = 230 * augValue; //keep the old F7 speed
		}
		else
		{
			speed = Default.GroundSpeed; //higher non-F7 speed
		}
	}
	else
	{
		speed = Default.GroundSpeed * augValue; //SP speed
	}

	return speed;
}

event Destroyed()
{
	if(AGM != None)
		AGM.PlayerLeave(self);

	Super.Destroyed();
}

// ----------------------------------------------------------------------
// UpdateInHand()
//
// Called every frame
// Checks the state of inHandPending and deals with animation and crap
// 1. Check for pending item
// 2. Play down anim (and deactivate) for inHand and wait for it to finish
// 3. Assign inHandPending to inHand (and SelectedItem)
// 4. Play up anim for inHand
// ----------------------------------------------------------------------

function UpdateInHand() //Cozmo: this entire setup ^ is horrible! Consider rewriting it all...
{
	local bool bSwitch;

	//sync up clientinhandpending.
	if (inHandPending != inHand)
		ClientInHandPending = inHandPending;

   //DEUS_EX AMSD  Don't let clients do this.
   if (Role < ROLE_Authority)
      return;

	if (inHand != inHandPending)
	{
		bInHandTransition = True;
		bSwitch = False;
		
		if (inHand != None)
		{
			// turn it off if it is on
			if (inHand.bActive)
				inHand.Activate();

			if (inHand.IsA('SkilledTool'))
			{
				if (inHand.IsInState('Idle'))
				{
					SkilledTool(inHand).PutDown();
				}
				else if (inHand.IsInState('Idle2'))
				{
					bSwitch = True;
				}
			}
			else if (inHand.IsA('DeusExWeapon'))
			{
				if (inHand.IsInState('Idle') || inHand.IsInState('Reload'))
					DeusExWeapon(inHand).PutDown();
				else if (inHand.IsInState('DownWeapon') && (Weapon == None))
					bSwitch = True;
			}
			else
			{
				bSwitch = True;
			}
		}
		else
		{
			bSwitch = True;
		}

		// OK to actually switch?
		if (bSwitch)
		{
			SetInHand(inHandPending);
			SelectedItem = inHandPending;

			if (inHand != None)
			{
				if (inHand.IsA('SkilledTool'))
					SkilledTool(inHand).BringUp();
				else if (inHand.IsA('DeusExWeapon'))
					SwitchWeapon(DeusExWeapon(inHand).InventoryGroup);
			}
		}
	}
	else
	{
		bInHandTransition = False;

		// Added this code because it's now possible to reselect an in-hand
		// item while we're putting it down, so we need to bring it back up...

		if (inHand != None)
		{
			// if we put the item away, bring it back up
			if (inHand.IsA('SkilledTool'))
			{
				if (inHand.IsInState('Idle2'))
					SkilledTool(inHand).BringUp();
			}
			else if (inHand.IsA('DeusExWeapon'))
			{
				if (inHand.IsInState('DownWeapon') && (Weapon == None))
					SwitchWeapon(DeusExWeapon(inHand).InventoryGroup);
			}
		}

	}

	UpdateCarcassEvent();
}

exec function ActivateBelt(int objectNum)
{
	local DeusExRootWindow root;
	local Inventory inv;
	local ANNAWeapon awep;

	if (RestrictInput())
		return;

	if ((Level.NetMode != NM_Standalone) && bBuySkills)
	{
		root = DeusExRootWindow(rootWindow);
		if ( root != None )
		{
			if ( root.hud.hms.OverrideBelt( Self, objectNum ))
				return;
		}
	}

	if (CarriedDecoration == None)
	{
		root = DeusExRootWindow(rootWindow);
		
		if (root != None)
		{
			inv = root.HUD.belt.GetObjectFromBelt(objectNum);
			
			awep = ANNAWeapon(Weapon);
			
			if(awep != none)
			{
				if(awep != inv)
				{
					if(awep.IsInState('ANNAReload'))
					{
						awep.GotoState('DownWeapon');
					}
				}
				
				awep.ScopeOff();
			}
			
			//Cozmo: don't equip from empty belt slots (except 9 lol, because some players use medbind to reload)
			if(objectNum == 9)
				root.ActivateObjectInBelt(objectNum);
			else if(inv != None)
				root.ActivateObjectInBelt(objectNum);
		}
	}
}

function int HealPlayer(int baseHealPoints, optional Bool bUseMedicineSkill)
{
	if(baseHealPoints > 10) //ignore regen, water fountains, snacks etc
		lastHealedTime = Level.TimeSeconds;
	
	Super.HealPlayer(baseHealPoints, bUseMedicineSkill);
}

//
// CreateKillerProfile
//
function CreateKillerProfile( Pawn killer, int damage, name damageType, String bodyPart )
{
	local DeusExPlayer pkiller;
	local DeusExProjectile proj;
	local DeusExDecoration decProj;
	local Augmentation anAug;
	local int augCnt;
	local DeusExWeapon w;
	local Skill askill;
	local String wShortString;
	local string lastTimeStr;

	if ( killProfile == None )
	{
		log("Warning:"$Self$" has a killProfile that is None!" );
		return;
	}
	else
		killProfile.Reset();

	pkiller = DeusExPlayer(killer);
	
	if ( pkiller != None )
	{
		killProfile.bValid = True;
		killProfile.name = pkiller.PlayerReplicationInfo.PlayerName;
		w = DeusExWeapon(pkiller.inHand);
		GetWeaponName( w, killProfile.activeWeapon );

		// What augs the killer was using
		if ( pkiller.AugmentationSystem != None )
		{
			killProfile.numActiveAugs = pkiller.AugmentationSystem.NumAugsActive();
			augCnt = 0;
			anAug = pkiller.AugmentationSystem.FirstAug;
			while ( anAug != None )
			{
				if ( anAug.bHasIt && anAug.bIsActive && !anAug.bAlwaysActive && (augCnt < ArrayCount(killProfile.activeAugs)))
				{
					killProfile.activeAugs[augCnt] = anAug.augmentationName;
					augCnt += 1;
				}
				anAug = anAug.next;
			}
		}
		else
			killProfile.numActiveAugs = 0;

		// My weapon and skill
		GetWeaponName( DeusExWeapon(inHand), killProfile.myActiveWeapon );
		if ( DeusExWeapon(inHand) != None )
		{
			if ( SkillSystem != None )
			{
				askill = SkillSystem.GetSkillFromClass(DeusExWeapon(inHand).GoverningSkill);
				killProfile.myActiveSkill = askill.skillName;
				killProfile.myActiveSkillLevel = askill.CurrentLevel;
			}
		}
		else
		{
			killProfile.myActiveWeapon = NoneString;
			killProfile.myActiveSkill = NoneString;
			killProfile.myActiveSkillLevel = 0;
		}
		// Fill in my own active augs
		if ( AugmentationSystem != None )
		{
			killProfile.myNumActiveAugs = AugmentationSystem.NumAugsActive();
			augCnt = 0;
			anAug = AugmentationSystem.FirstAug;
			while ( anAug != None )
			{
				if ( anAug.bHasIt && anAug.bIsActive && !anAug.bAlwaysActive && (augCnt < ArrayCount(killProfile.myActiveAugs)))
				{
					killProfile.myActiveAugs[augCnt] = anAug.augmentationName;
					augCnt += 1;
				}
				anAug = anAug.next;
			}
		}
		
		killProfile.streak = (pkiller.PlayerReplicationInfo.Streak + 1);
		killProfile.healthLow = pkiller.HealthLegLeft;
		killProfile.healthMid =  pkiller.HealthTorso;
		killProfile.healthHigh = pkiller.HealthHead;
		killProfile.remainingBio = pkiller.Energy;
		killProfile.damage = damage;
		killProfile.bodyLoc = bodyPart;
		killProfile.killerLoc = pkiller.Location;
		
		if(pkiller.IsA('ANNAPlayer') && ANNAPlayer(pkiller).lastHealedTime > 0 && Level.TimeSeconds - ANNAPlayer(pkiller).lastHealedTime < 15)
		{
			//CDXkillerProfile(killProfile).myLastHealedTime = float(int((Level.TimeSeconds - ANNAPlayer(pkiller).lastHealedTime) * 100) / 100); //Cozmo: this displays as 0.800000 lol... 
			
			lastTimeStr = string(Level.TimeSeconds - ANNAPlayer(pkiller).lastHealedTime);
			CDXkillerProfile(killProfile).myLastHealedTime = Mid(lastTimeStr, 0, Len(lastTimeStr) - 4);
		}
		else
		{
			CDXkillerProfile(killProfile).myLastHealedTime = "";
		}
	}
	else
	{
		killProfile.bValid = False;
		return;
	}

	killProfile.methodStr = NoneString;

	switch( damageType )
	{
		case 'AutoShot':
			killProfile.methodStr = WithTheString $ AutoTurret(myTurretKiller).titleString  $ "!";
			killProfile.bTurretKilled = True;
			killProfile.killerLoc = AutoTurret(myTurretKiller).Location;
			if ( pkiller.SkillSystem != None )
			{
				killProfile.activeSkill = class'SkillComputer'.Default.skillName;
				killProfile.activeSkillLevel = pkiller.SkillSystem.GetSkillLevel(class'SkillComputer');
			}
			break;
		case 'PoisonEffect':
			killProfile.methodStr = PoisonString $ "!";
			killProfile.bPoisonKilled = True;
			killProfile.activeSkill = NoneString;
			killProfile.activeSkillLevel = 0;
			break;
		case 'Burned':
		case 'Flamed':
			if (( WeaponPlasmaRifle(w) != None ) || ( WeaponFlamethrower(w) != None ))
			{
				// Use the weapon if it's still in hand
			}
			else
			{
				killProfile.methodStr = BurnString $ "!";
				killProfile.bBurnKilled = True;
				killProfile.activeSkill = NoneString;
				killProfile.activeSkillLevel = 0;
			}
			break;
	}
	if ( killProfile.methodStr ~= NoneString )
	{
		proj = DeusExProjectile(myProjKiller);
		decProj = DeusExDecoration(myProjKiller);

		if (( killer != None ) && (proj != None) && (!(proj.itemName ~= "")) )
		{
			if ( (LAM(myProjKiller) != None) && (LAM(myProjKiller).bProximityTriggered) )
			{
				killProfile.bProximityKilled = True;
				killProfile.killerLoc = LAM(myProjKiller).Location;
				killProfile.myActiveSkill = class'SkillDemolition'.Default.skillName;
				if ( SkillSystem != None )
					killProfile.myActiveSkillLevel = SkillSystem.GetSkillLevel(class'SkillDemolition');
				else
					killProfile.myActiveSkillLevel = 0;
			}
			else
				killProfile.bProjKilled = True;
			killProfile.methodStr = WithString $ proj.itemArticle $ " " $ proj.itemName $ "!";
			GetSkillInfoFromProj( pkiller, myProjKiller );
		}
		else if (( killer != None ) && ( decProj != None ) && (!(decProj.itemName ~= "" )) )
		{
			killProfile.methodStr = WithString $ decProj.itemArticle $ " " $ decProj.itemName $ "!";
			killProfile.bProjKilled = True;
			GetSkillInfoFromProj( pkiller, myProjKiller );
		}
		else if ((killer != None) && (w != None))
		{
			GetWeaponName( w, wShortString );
			killProfile.methodStr = WithString $ w.itemArticle $ " " $ wShortString $ "!";
			askill = pkiller.SkillSystem.GetSkillFromClass(w.GoverningSkill);
			killProfile.activeSkill = askill.skillName;
			killProfile.activeSkillLevel = askill.CurrentLevel;
		}
		else
			log("Warning: Failed to determine killer method killer:"$killer$" damage:"$damage$" damageType:"$damageType$" " );
	}
	// If we still failed dump this to log, and I'll see if there's a condition slipping through...
	if ( killProfile.methodStr ~= NoneString )
	{
		log("===>Warning: Failed to get killer method:"$Self$" damageType:"$damageType$" " );
		killProfile.bValid = False;
	}
}

//-----------------------------------------------------------------------------
//	HACKS
//
// Cozmo: CDXExtension needs to be loaded before CDX, so that we can put hooks in
// it (so others can avoid MTL problems). Annoyingly, this means CDXExtension can't
// access CDX directly, as it loads first. You can get around this with some hax
//-----------------------------------------------------------------------------

/*
//to set clientside strings (such as team names, scoreboard stuff, etc), force them to exec this via Player.ConsoleCommand()
exec simulated function SetClientVar(string S) //wasn't sim before
{
	if(Len(S) > 63)
		S = Left(S,63);

	if(mid(S, 0, 6) == "mpobj ")
		mpObjective = mid(S, 6);
}*/


simulated function SetMPObj(string S)
{
	mpObjective = S;
}

function Trigger(actor Other, pawn EventInstigator )
{
	local actor a;
	// silly hack idea:
	// in classes from non-CDX packages: set player.Event, call player.Trigger() to execute. Can even return vars via player.Tag lol

	if(Event == 'dsoc1')
	{
		ClientsideEffects(1, Other);
	}
	else if(Event == 'dsoc2')
	{
		ClientsideEffects(2, Other);
	}
	else if(Event == 'dsoc3')
	{
		ClientsideEffects(3, Other);
	}
	else if(Event == 'dsoc4')
	{
		PlayHitFeedback();
	}
	else if(Event == 'dsoc5')
	{
		//set obj str
		SetMPObj(StrStartMap);
	}
	else if(Event == 'dsoc6')
	{
		ClientsideEffects(4,other);
	//	broadcastmessage("debug: other is "$other);
	}
	else if(Event == 'playerhelp')
	{
		ClientMessage("|p1CDX Version "$CDXVerStr$", say |p7/help|p1 for commands");
	}
	else if(Event == 'ds1')
	{
		SetTimer2('dsoc3', 3.0);
	}
	else if(Event == 'ds2')
	{
		SkillPointsAvail = DeusExMPGame(Level.Game).SkillsAvail;
	}
	else if(Event == 'ds3') //spectate after a timer
	{
		aSpecTimer = none;
		spectateStartTime = Level.TimeSeconds;
		GotoState('PlayerSpectating');
		BroadcastMessage(PlayerReplicationInfo.PlayerName@"started spectating.");
	}
	else if(Event == 'ds4') //suicide after a timer
	{
		aSuiTimer = none;
		//Super.Suicide();
		KilledBy(Self);
	}
	
	Event = '';
}

simulated function ClientsideEffects(int type, optional actor other)
{
	local ANNAWeapon weppy;
	local MultiplayerMessageWin2 mmw2;
	
	if(type == 1)
	{
		weppy = ANNAWeapon(Other);
		
		if(weppy == None)
			return;
		
		if(weppy.bMissingAnims == false)
		{
			if(weppy.bHandToHand)
				weppy.PlayAnim('Attack');
			else
				weppy.PlayAnim('Shoot');
		}
				
		//PlayAnim('Shoot', 0.8);
		//weppy.PlaySound(weppy.FireSound, SLOT_None, TransientSoundVolume,, 2048 ); //(Sound snd, ESoundSlot Slot, float Volume, float Radius )
		//PlaySimSound(FireSound, SLOT_None, TransientSoundVolume, 2048 ); //(Sound snd, ESoundSlot Slot, float Volume, float Radius )
		
	   if (weppy.bHasMuzzleFlash == false)
		  return;
		  
		if (FRand() < 0.5)
			weppy.MultiSkins[2] = Texture'FlatFXTex34';
		else
			weppy.MultiSkins[2] = Texture'FlatFXTex37';

		weppy.MuzzleFlashLight();
		weppy.SetTimer(0.1, False);
	}
	else if(type == 2)
	{
		if(CheckDemoPlayback()) //dumb hack so that wep sounds work in demos
		{
			weppy = ANNAWeapon(Other);
			
			if(weppy != None)
				weppy.PlaySound(weppy.FireSound, SLOT_None, weppy.TransientSoundVolume);
		}
	}
	else if(type == 3) //for killerprofile end
	{
		DeusExRootWindow(RootWindow).PopWindow();
	}
	else if(type == 4)
	{
	//	clientmessage("debug: dsoc type 4 called");
	//	clientmessage("debug: dsoc other is "$other);
		
		if(other != None)
		{
	//		clientmessage("debug: trying to destroy "$other);
			other.bHidden = true;
			other.Destroy();
		}
	}
	else if(type == 5) //end killerprofile then show final scoreboard after
	{
		DeusExRootWindow(RootWindow).PopWindow();
	}
}

//{
//	if(Level.NetMode != NM_DedicatedServer)
//	{
//		if(type == 1) //animate other players
//		{
//			ANNAWeapon(other).PlayWepFiring();
//		}
//	}
//}

function ChangeName(coerce string S)
{
	//V52(S);
	local string tempName;
	
	tempName = S;
	V52(S);
	
	if(S != "") //this didn't really work anyway...
	{
		//tempName = tempName$"|p1";
		Level.Game.ChangeName(self, tempName, False);
	}
}

function V522 (out string V92) //V52 in MTL
{
	V92=Left(V92,20);
	
	if(Level.NetMode == NM_StandAlone)
		return;
	
	//V54(V92,False); //strips out the colours from player name, but we only want to strip them from chat
	
	if ( V92 == "" )
	{
		V92="Player";
	}
	
	if ( (V92 ~= "Player") || (V92 ~= "PIayer") || (V92 ~= "P1ayer") )
	{
		V92=V92 $ "_" $ string(Rand(999));
	}
	else
	{
		if(V51(V92))
		{
			V92=Left(V92,17) $ "_" $ string(Rand(99));
		}
	}
}

function string V502 () //v50 in MTL
{
	//return PlayerReplicationInfo.PlayerName $ "(" $ string(PlayerReplicationInfo.PlayerID) $ ")";
	return "|ccccccc("$String(PlayerReplicationInfo.PlayerID)$")|p1 "$PlayerReplicationInfo.PlayerName;
}
/*
function PlayTakeHitSound(int Damage, name damageType, int Mult)
{
	local float rnd;
	
	// Body hit sound for multiplayer only
	if (((damageType=='Shot') || (damageType=='AutoShot'))  && ( Level.NetMode != NM_Standalone ))
	{
		//PlaySound(sound'BodyHit', SLOT_Pain, FMax(Mult * TransientSoundVolume, Mult * 2.0),,, RandomPitch());
		PlaySound(sound'BodyHit', SLOT_Pain, FMax(Mult * TransientSoundVolume, Mult * 2.0) * (FRand() * 0.6 + 0.2),,, 1.25 + FRand() * 0.15); //Phil's version, definitely better
	}
		
	if ( Level.TimeSeconds - LastPainSound < FRand() + 0.5)
		return;

	LastPainSound = Level.TimeSeconds;

	if (Region.Zone.bWaterZone)
	{
		if (damageType == 'Drowned')
		{
			if (FRand() < 0.8)
				PlaySound(sound'MaleDrown', SLOT_Pain, FMax(Mult * TransientSoundVolume, Mult * 2.0),,, RandomPitch());
		}
		else
			PlaySound(sound'MalePainSmall', SLOT_Pain, FMax(Mult * TransientSoundVolume, Mult * 2.0),,, RandomPitch());
	}
	else
	{
		if ((damageType == 'TearGas') || (damageType == 'HalonGas'))
			PlaySound(sound'MaleEyePain', SLOT_Pain, FMax(Mult * TransientSoundVolume, Mult * 2.0),,, RandomPitch());
		else if (damageType == 'PoisonGas')
			PlaySound(sound'MaleCough', SLOT_Pain, FMax(Mult * TransientSoundVolume, Mult * 2.0),,, RandomPitch());
		else
		{
			rnd = FRand();
			if (rnd < 0.33)
				PlaySound(sound'MalePainSmall', SLOT_Pain, FMax(Mult * TransientSoundVolume, Mult * 2.0),,, RandomPitch());
			else if (rnd < 0.66)
				PlaySound(sound'MalePainMedium', SLOT_Pain, FMax(Mult * TransientSoundVolume, Mult * 2.0),,, RandomPitch());
			else
				PlaySound(sound'MalePainLarge', SLOT_Pain, FMax(Mult * TransientSoundVolume, Mult * 2.0),,, RandomPitch());
		}
	AISendEvent('LoudNoise', EAITYPE_Audio, FMax(Mult * TransientSoundVolume, Mult * 2.0));

	}
}*/


// ----------------------------------------------------------------------
// NextBeltItem()
// ----------------------------------------------------------------------

exec function NextBeltItem()
{
	local DeusExRootWindow root;
	local int slot, startSlot;

	if (RestrictInput())
		return;

	if (CarriedDecoration == None)
	{
		slot = 0;
		root = DeusExRootWindow(rootWindow);
		if (root != None)
		{
			if (ClientInHandPending != None)
				slot = ClientInHandPending.beltPos;
			else if (inHandPending != None)
				slot = inHandPending.beltPos;
			else if (inHand != None)
				slot = inHand.beltPos;

			startSlot = slot;
			do
			{
				if (++slot >= 10)
					slot = 0;
			}
			until (root.ActivateObjectInBelt(slot) || (startSlot == slot));

			clientInHandPending = root.hud.belt.GetObjectFromBelt(slot);
		}
	}
}

// ----------------------------------------------------------------------
// PrevBeltItem()
// ----------------------------------------------------------------------

exec function PrevBeltItem()
{
	local DeusExRootWindow root;
	local int slot, startSlot;

	if (RestrictInput())
		return;

	if (CarriedDecoration == None)
	{
		slot = 1;
		root = DeusExRootWindow(rootWindow);
		if (root != None)
		{
			if (ClientInHandPending != None)
				slot = ClientInHandPending.beltPos;
			else  if (inHandPending != None)
				slot = inHandPending.beltPos;
			else if (inHand != None)
				slot = inHand.beltPos;

			startSlot = slot;
			do
			{
				if (--slot <= -1)
					slot = 9;
			}
			until (root.ActivateObjectInBelt(slot) || (startSlot == slot));

			clientInHandPending = root.hud.belt.GetObjectFromBelt(slot);
		}
	}
}

DefaultProperties
{
	//HMTex=Texture'CDX_100.UI.DX_HitMarker'
	//HMTex=Texture'DeusExUI.Icons.DamageIconCenter'
	CDXVerStr="1.30"
	HitFeedback=Sound'CDXExtension.Generic.QFeedBack'
	bAlwaysRelevant=true
    bMuted=false
	defaultMaxFrobDistance=112.00
	PlayerReplicationInfoClass=class'ANNAPRI'
	groundSpeed=280.000000
	mpGroundSpeed=280.000000
	//accelRate=700 //130
	AirControl=0.15
	logTimeout=20.000000
	mpObjective="The player with the most kills when the time runs out wins!"
	CarcassType=class'ANNACarcass'
}
//	groundSpeed=280.000000