//=============================================================================
// WeaponNanoSword.
//=============================================================================
class ANNAWeaponDTS extends ANNAWeapon;

var name lastAnim;

state DownWeapon
{
	function BeginState()
	{
		Super.BeginState();
		LightType = LT_None;
	}
}

state Idle
{
	function BeginState()
	{
		Super.BeginState();
		LightType = LT_Steady;
	}
}

auto state Pickup
{
	function EndState()
	{
		Super.EndState();
		LightType = LT_None;
	}
}

simulated function StartAtkAnim() //all code in here is borrowed from Lexi's DXW2!
{
	local float rnd, mult;
	local name anim;
	
	rnd = FRand();
	mult = 1;
	
	//randomly choose one. Make sure they're the same speed!
	if (rnd < 0.33)
		anim = 'Attack';
	else if (rnd < 0.66)
		anim = 'Attack2';
	else
		anim = 'Attack3';
			
	while(anim == lastAnim) //added by Cozmo. ps: even though DTS technically only has 2 anims (1 and 2 are duplicates), 3 looks so shitty that I'll leave it as 1/3 chance
	{
		rnd = FRand();
	
		if (rnd < 0.33)
			anim = 'Attack';
		else if (rnd < 0.66)
			anim = 'Attack2';
		else
			anim = 'Attack3';
	}

	PlayAnim(anim,mult,0.1);
	PlaySound(FireSound);
	lastAnim = anim;
}

function int GetWeaponDamageSkill(int userLevel, optional actor target)
{
	if(userLevel == 0) //untrained (sp-only?)
		return 65;
	if(userLevel == 1) //trained
		return 75;
	if(userLevel == 2) //advanced
		return 85;
	if(userLevel == 3) //master
		return 100;
	if(userLevel == 4) //master + targ
		return 110;
}

defaultproperties
{
	atkDelayTime=0.35
	shotTime=0.75
	bringUpTime=1.20
     LowAmmoWaterMark=0
     GoverningSkill=Class'DeusEx.SkillWeaponLowTech'
     NoiseLevel=0.050000
     reloadTime=0.000000
     HitDamage=20
     maxRange=130
     AccurateRange=130
     BaseAccuracy=1.000000
     AreaOfEffect=AOE_Cone
     bHasMuzzleFlash=False
     bHandToHand=True
     SwingOffset=(X=24.000000,Z=2.000000)
     mpHitDamage=10
     mpBaseAccuracy=1.000000
     mpAccurateRange=130
     mpMaxRange=114
     AmmoName=Class'DeusEx.AmmoNone'
     ReloadCount=0
     bInstantHit=True
     FireOffset=(X=-21.000000,Y=16.000000,Z=27.000000)
     shakemag=20.000000
     FireSound=Sound'DeusExSounds.Weapons.NanoSwordFire'
     SelectSound=Sound'DeusExSounds.Weapons.NanoSwordSelect'
     Misc1Sound=Sound'DeusExSounds.Weapons.NanoSwordHitFlesh'
     Misc2Sound=Sound'DeusExSounds.Weapons.NanoSwordHitHard'
     Misc3Sound=Sound'DeusExSounds.Weapons.NanoSwordHitSoft'
     InventoryGroup=14
     ItemName="Dragon's Tooth Sword"
     ItemArticle="the"
     PlayerViewOffset=(X=21.000000,Y=-16.000000,Z=-27.000000)
     PlayerViewMesh=LodMesh'DeusExItems.NanoSword'
     PickupViewMesh=LodMesh'DeusExItems.NanoSwordPickup'
     ThirdPersonMesh=LodMesh'DeusExItems.NanoSword3rd'
     LandSound=Sound'DeusExSounds.Generic.DropLargeWeapon'
     Icon=Texture'DeusExUI.Icons.BeltIconDragonTooth'
     largeIcon=Texture'DeusExUI.Icons.LargeIconDragonTooth'
     largeIconWidth=205
     largeIconHeight=46
     invSlotsX=4
     Description="The true weapon of a modern warrior, the Dragon's Tooth is not a sword in the traditional sense, but a nanotechnologically constructed blade that is dynamically 'forged' on command into a non-eutactic solid. Nanoscale whetting devices insure that the blade is both unbreakable and lethally sharp."
     beltDescription="DRAGON"
     Mesh=LodMesh'DeusExItems.NanoSwordPickup'
     CollisionRadius=32.000000
     CollisionHeight=2.400000
     LightType=LT_Steady
     LightEffect=LE_WateryShimmer
     LightBrightness=224
     LightHue=160
     LightSaturation=64
     LightRadius=4
     Mass=20.000000
}
